import{S as Bb,i as Yb,s as Qb,e as s,k as d,w as _,t as n,M as Jb,c as a,d as t,m as c,a as i,x as b,h as r,b as l,G as e,g as m,y as v,q as y,o as D,B as w,v as Kb,L as nd}from"../../chunks/vendor-hf-doc-builder.js";import{T as Tu}from"../../chunks/Tip-hf-doc-builder.js";import{D as k}from"../../chunks/Docstring-hf-doc-builder.js";import{C as rn}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as we}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as od}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";import{P as Xb}from"../../chunks/PipelineTag-hf-doc-builder.js";function Zb(I){let f,E,T,u,x;return u=new rn({props:{code:`from transformers import DetrConfig, DetrModel

# Initializing a DETR facebook/detr-resnet-50 style configuration
configuration = DetrConfig()

# Initializing a model (with random weights) from the facebook/detr-resnet-50 style configuration
model = DetrModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrConfig, DetrModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a DETR facebook/detr-resnet-50 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = DetrConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the facebook/detr-resnet-50 style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){m(p,f,g),e(f,E),m(p,T,g),v(u,p,g),x=!0},p:nd,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function ev(I){let f,E,T,u,x;return{c(){f=s("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),T=s("code"),u=n("Module"),x=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),T=a(g,"CODE",{});var H=i(T);u=r(H,"Module"),H.forEach(t),x=r(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(p,g){m(p,f,g),e(f,E),e(f,T),e(T,u),e(f,x)},d(p){p&&t(f)}}}function tv(I){let f,E,T,u,x;return u=new rn({props:{code:`from transformers import AutoImageProcessor, DetrModel
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("facebook/detr-resnet-50")
model = DetrModel.from_pretrained("facebook/detr-resnet-50")

# prepare image for the model
inputs = image_processor(images=image, return_tensors="pt")

# forward pass
outputs = model(**inputs)

# the last hidden states are the final query embeddings of the Transformer decoder
# these are of shape (batch_size, num_queries, hidden_size)
last_hidden_states = outputs.last_hidden_state
list(last_hidden_states.shape)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetrModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrModel.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare image for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># the last hidden states are the final query embeddings of the Transformer decoder</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># these are of shape (batch_size, num_queries, hidden_size)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>last_hidden_states = outputs.last_hidden_state
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">list</span>(last_hidden_states.shape)
[<span class="hljs-number">1</span>, <span class="hljs-number">100</span>, <span class="hljs-number">256</span>]`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){m(p,f,g),e(f,E),m(p,T,g),v(u,p,g),x=!0},p:nd,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function ov(I){let f,E,T,u,x;return{c(){f=s("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),T=s("code"),u=n("Module"),x=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),T=a(g,"CODE",{});var H=i(T);u=r(H,"Module"),H.forEach(t),x=r(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(p,g){m(p,f,g),e(f,E),e(f,T),e(T,u),e(f,x)},d(p){p&&t(f)}}}function nv(I){let f,E,T,u,x;return u=new rn({props:{code:`from transformers import AutoImageProcessor, DetrForObjectDetection
import torch
from PIL import Image
import requests

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("facebook/detr-resnet-50")
model = DetrForObjectDetection.from_pretrained("facebook/detr-resnet-50")

inputs = image_processor(images=image, return_tensors="pt")
outputs = model(**inputs)

# convert outputs (bounding boxes and class logits) to COCO API
target_sizes = torch.tensor([image.size[::-1]])
results = image_processor.post_process_object_detection(outputs, threshold=0.9, target_sizes=target_sizes)[
    0
]

for score, label, box in zip(results["scores"], results["labels"], results["boxes"]):
    box = [round(i, 2) for i in box.tolist()]
    print(
        f"Detected {model.config.id2label[label.item()]} with confidence "
        f"{round(score.item(), 3)} at location {box}"
    )`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetrForObjectDetection
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># convert outputs (bounding boxes and class logits) to COCO API</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>target_sizes = torch.tensor([image.size[::-<span class="hljs-number">1</span>]])
<span class="hljs-meta">&gt;&gt;&gt; </span>results = image_processor.post_process_object_detection(outputs, threshold=<span class="hljs-number">0.9</span>, target_sizes=target_sizes)[
<span class="hljs-meta">... </span>    <span class="hljs-number">0</span>
<span class="hljs-meta">... </span>]

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> score, label, box <span class="hljs-keyword">in</span> <span class="hljs-built_in">zip</span>(results[<span class="hljs-string">&quot;scores&quot;</span>], results[<span class="hljs-string">&quot;labels&quot;</span>], results[<span class="hljs-string">&quot;boxes&quot;</span>]):
<span class="hljs-meta">... </span>    box = [<span class="hljs-built_in">round</span>(i, <span class="hljs-number">2</span>) <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> box.tolist()]
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;Detected <span class="hljs-subst">{model.config.id2label[label.item()]}</span> with confidence &quot;</span>
<span class="hljs-meta">... </span>        <span class="hljs-string">f&quot;<span class="hljs-subst">{<span class="hljs-built_in">round</span>(score.item(), <span class="hljs-number">3</span>)}</span> at location <span class="hljs-subst">{box}</span>&quot;</span>
<span class="hljs-meta">... </span>    )
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.998</span> at location [<span class="hljs-number">40.16</span>, <span class="hljs-number">70.81</span>, <span class="hljs-number">175.55</span>, <span class="hljs-number">117.98</span>]
Detected remote <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.996</span> at location [<span class="hljs-number">333.24</span>, <span class="hljs-number">72.55</span>, <span class="hljs-number">368.33</span>, <span class="hljs-number">187.66</span>]
Detected couch <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.995</span> at location [-<span class="hljs-number">0.02</span>, <span class="hljs-number">1.15</span>, <span class="hljs-number">639.73</span>, <span class="hljs-number">473.76</span>]
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.999</span> at location [<span class="hljs-number">13.24</span>, <span class="hljs-number">52.05</span>, <span class="hljs-number">314.02</span>, <span class="hljs-number">470.93</span>]
Detected cat <span class="hljs-keyword">with</span> confidence <span class="hljs-number">0.999</span> at location [<span class="hljs-number">345.4</span>, <span class="hljs-number">23.85</span>, <span class="hljs-number">640.37</span>, <span class="hljs-number">368.72</span>]`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){m(p,f,g),e(f,E),m(p,T,g),v(u,p,g),x=!0},p:nd,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function rv(I){let f,E,T,u,x;return{c(){f=s("p"),E=n("Although the recipe for forward pass needs to be defined within this function, one should call the "),T=s("code"),u=n("Module"),x=n(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Although the recipe for forward pass needs to be defined within this function, one should call the "),T=a(g,"CODE",{});var H=i(T);u=r(H,"Module"),H.forEach(t),x=r(g,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),g.forEach(t)},m(p,g){m(p,f,g),e(f,E),e(f,T),e(T,u),e(f,x)},d(p){p&&t(f)}}}function sv(I){let f,E,T,u,x;return u=new rn({props:{code:`import io
import requests
from PIL import Image
import torch
import numpy

from transformers import AutoImageProcessor, DetrForSegmentation
from transformers.image_transforms import rgb_to_id

url = "http://images.cocodataset.org/val2017/000000039769.jpg"
image = Image.open(requests.get(url, stream=True).raw)

image_processor = AutoImageProcessor.from_pretrained("facebook/detr-resnet-50-panoptic")
model = DetrForSegmentation.from_pretrained("facebook/detr-resnet-50-panoptic")

# prepare image for the model
inputs = image_processor(images=image, return_tensors="pt")

# forward pass
outputs = model(**inputs)

# Use the \`post_process_panoptic_segmentation\` method of the \`image_processor\` to retrieve post-processed panoptic segmentation maps
# Segmentation results are returned as a list of dictionaries
result = image_processor.post_process_panoptic_segmentation(outputs, target_sizes=[(300, 500)])

# A tensor of shape (height, width) where each value denotes a segment id, filled with -1 if no segment is found
panoptic_seg = result[0]["segmentation"]
# Get prediction score and segment_id to class_id mapping of each segment
panoptic_segments_info = result[0]["segments_info"]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> io
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> requests
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoImageProcessor, DetrForSegmentation
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers.image_transforms <span class="hljs-keyword">import</span> rgb_to_id

<span class="hljs-meta">&gt;&gt;&gt; </span>url = <span class="hljs-string">&quot;http://images.cocodataset.org/val2017/000000039769.jpg&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = Image.<span class="hljs-built_in">open</span>(requests.get(url, stream=<span class="hljs-literal">True</span>).raw)

<span class="hljs-meta">&gt;&gt;&gt; </span>image_processor = AutoImageProcessor.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50-panoptic&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForSegmentation.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50-panoptic&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># prepare image for the model</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = image_processor(images=image, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># forward pass</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(**inputs)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Use the \`post_process_panoptic_segmentation\` method of the \`image_processor\` to retrieve post-processed panoptic segmentation maps</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Segmentation results are returned as a list of dictionaries</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>result = image_processor.post_process_panoptic_segmentation(outputs, target_sizes=[(<span class="hljs-number">300</span>, <span class="hljs-number">500</span>)])

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># A tensor of shape (height, width) where each value denotes a segment id, filled with -1 if no segment is found</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>panoptic_seg = result[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segmentation&quot;</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Get prediction score and segment_id to class_id mapping of each segment</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>panoptic_segments_info = result[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;segments_info&quot;</span>]`}}),{c(){f=s("p"),E=n("Examples:"),T=d(),_(u.$$.fragment)},l(p){f=a(p,"P",{});var g=i(f);E=r(g,"Examples:"),g.forEach(t),T=c(p),b(u.$$.fragment,p)},m(p,g){m(p,f,g),e(f,E),m(p,T,g),v(u,p,g),x=!0},p:nd,i(p){x||(y(u.$$.fragment,p),x=!0)},o(p){D(u.$$.fragment,p),x=!1},d(p){p&&t(f),p&&t(T),w(u,p)}}}function av(I){let f,E,T,u,x,p,g,H,rd,wa,Te,He,mr,Lt,sd,pr,ad,Ta,Ge,id,Rt,dd,cd,xa,sn,ld,Ea,an,fr,hd,$a,_e,md,Mt,pd,fd,Ut,ud,gd,ka,We,_d,dn,bd,vd,Fa,F,yd,ur,Dd,wd,gr,Td,xd,_r,Ed,$d,br,kd,Fd,vr,jd,Od,yr,zd,Cd,Dr,Pd,qd,wr,Id,Nd,ja,P,Ad,Tr,Sd,Ld,xr,Rd,Md,Er,Ud,Hd,$r,Gd,Wd,kr,Vd,Bd,Fr,Yd,Qd,Oa,J,Jd,jr,Kd,Xd,Ht,Zd,ec,Gt,tc,oc,za,K,nc,cn,rc,sc,ln,ac,ic,hn,dc,cc,Ca,mn,lc,Pa,j,ne,hc,Or,mc,pc,zr,fc,uc,pn,gc,_c,bc,Cr,vc,yc,re,Dc,Pr,wc,Tc,fn,xc,Ec,qr,$c,kc,Fc,se,jc,Ir,Oc,zc,un,Cc,Pc,Nr,qc,Ic,Nc,B,Ac,Ar,Sc,Lc,Sr,Rc,Mc,Lr,Uc,Hc,Wt,Gc,Wc,Vc,N,gn,Bc,Yc,_n,Qc,Jc,Vt,Kc,Xc,Rr,Zc,el,bn,tl,ol,Mr,nl,rl,sl,ae,al,vn,il,dl,Ur,cl,ll,yn,hl,ml,pl,xe,fl,Hr,ul,gl,Bt,_l,bl,qa,Dn,vl,Ia,wn,yl,Na,Yt,Aa,Tn,Dl,Sa,Qt,La,xn,wl,Ra,Jt,Ma,En,Tl,Ua,Ve,Gr,ie,Wr,xl,El,Vr,$l,kl,Br,Fl,jl,Yr,Ol,zl,S,de,Qr,Jr,Cl,Pl,Kr,ql,Il,Xr,Nl,Al,Zr,Sl,Ll,ce,es,ts,Rl,Ml,os,$n,Ul,Hl,ns,kn,Gl,Wl,rs,Fn,Vl,Bl,le,ss,as,Yl,Ql,is,Jl,Kl,ds,Xl,Zl,cs,eh,th,he,Kt,ls,oh,nh,jn,rh,sh,Ee,ah,hs,ih,dh,ms,ch,lh,hh,L,mh,ps,ph,fh,fs,uh,gh,us,_h,bh,gs,vh,yh,_s,Dh,wh,Th,me,xh,bs,Eh,$h,vs,kh,Fh,ys,jh,Oh,zh,pe,On,Ds,Ch,Ph,qh,ws,Ts,Ih,Nh,xs,Es,Ah,Sh,Xt,$s,Lh,Rh,ks,Mh,Uh,fe,Fs,js,Hh,Gh,Zt,Os,Wh,Vh,zs,Bh,Yh,$e,Cs,Qh,Jh,Ps,Kh,Xh,qs,Zh,em,ue,Is,tm,om,Ns,nm,rm,As,sm,am,Ss,im,Ha,$,dm,zn,cm,lm,Ls,hm,mm,Rs,pm,fm,Ms,um,gm,Cn,_m,bm,Us,vm,ym,Hs,Dm,wm,eo,Tm,xm,to,Em,$m,Ga,ke,Be,Gs,oo,km,Ws,Fm,Wa,Pn,jm,Va,no,Ba,qn,ge,Om,In,zm,Cm,Nn,Pm,qm,ro,Im,Nm,Ya,An,Am,Qa,Fe,Ye,Vs,so,Sm,Bs,Lm,Ja,je,ao,Rm,Ys,Mm,Ka,Oe,io,Um,co,Hm,Sn,Gm,Wm,Xa,ze,lo,Vm,ho,Bm,Ln,Ym,Qm,Za,Ce,Qe,Qs,mo,Jm,Js,Km,ei,Y,po,Xm,Pe,Zm,Rn,ep,tp,fo,op,np,rp,qe,sp,Mn,ap,ip,Un,dp,cp,lp,Je,ti,Ie,Ke,Ks,uo,hp,Xs,mp,oi,z,go,pp,Zs,fp,up,Xe,_o,gp,ea,_p,bp,Ze,bo,vp,vo,yp,Hn,Dp,wp,Tp,et,yo,xp,Do,Ep,Gn,$p,kp,Fp,tt,wo,jp,To,Op,Wn,zp,Cp,Pp,ot,xo,qp,Eo,Ip,Vn,Np,Ap,ni,Ne,nt,ta,$o,Sp,oa,Lp,ri,C,ko,Rp,rt,Fo,Mp,na,Up,Hp,st,jo,Gp,ra,Wp,Vp,at,Oo,Bp,zo,Yp,Bn,Qp,Jp,Kp,it,Co,Xp,Po,Zp,Yn,ef,tf,of,dt,qo,nf,Io,rf,Qn,sf,af,df,ct,No,cf,Ao,lf,Jn,hf,mf,si,Ae,lt,sa,So,pf,aa,ff,ai,R,Lo,uf,ia,gf,_f,Ro,bf,Kn,vf,yf,Df,Mo,wf,Uo,Tf,xf,Ef,X,Ho,$f,Se,kf,Xn,Ff,jf,da,Of,zf,Cf,ht,Pf,mt,ii,Le,pt,ca,Go,qf,la,If,di,M,Wo,Nf,ha,Af,Sf,Vo,Lf,Zn,Rf,Mf,Uf,Bo,Hf,Yo,Gf,Wf,Vf,Z,Qo,Bf,Re,Yf,er,Qf,Jf,ma,Kf,Xf,Zf,ft,eu,ut,ci,Me,gt,pa,Jo,tu,fa,ou,li,U,Ko,nu,ua,ru,su,Xo,au,tr,iu,du,cu,Zo,lu,en,hu,mu,pu,ee,tn,fu,Ue,uu,or,gu,_u,ga,bu,vu,yu,_t,Du,bt,hi;return p=new we({}),Lt=new we({}),Yt=new rn({props:{code:`from transformers import DetrForObjectDetection

model = DetrForObjectDetection.from_pretrained("facebook/detr-resnet-50")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrForObjectDetection

<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection.from_pretrained(<span class="hljs-string">&quot;facebook/detr-resnet-50&quot;</span>)`}}),Qt=new rn({props:{code:`from transformers import DetrConfig, DetrForObjectDetection

config = DetrConfig()
model = DetrForObjectDetection(config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DetrConfig, DetrForObjectDetection

<span class="hljs-meta">&gt;&gt;&gt; </span>config = DetrConfig()
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection(config)`}}),Jt=new rn({props:{code:`config = DetrConfig(use_pretrained_backbone=False)
model = DetrForObjectDetection(config)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>config = DetrConfig(use_pretrained_backbone=<span class="hljs-literal">False</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = DetrForObjectDetection(config)`}}),oo=new we({}),no=new Xb({props:{pipeline:"object-detection"}}),so=new we({}),ao=new k({props:{name:"class transformers.models.detr.modeling_detr.DetrModelOutput",anchor:"transformers.models.detr.modeling_detr.DetrModelOutput",parameters:[{name:"last_hidden_state",val:": FloatTensor = None"},{name:"past_key_values",val:": typing.Optional[typing.Tuple[typing.Tuple[torch.FloatTensor]]] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"intermediate_hidden_states",val:": typing.Optional[torch.FloatTensor] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrModelOutput.intermediate_hidden_states",description:`<strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(config.decoder_layers, batch_size, sequence_length, hidden_size)</code>, <em>optional</em>, returned when <code>config.auxiliary_loss=True</code>) &#x2014;
Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.`,name:"intermediate_hidden_states"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L96"}}),io=new k({props:{name:"class transformers.models.detr.modeling_detr.DetrObjectDetectionOutput",anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"loss_dict",val:": typing.Optional[typing.Dict] = None"},{name:"logits",val:": FloatTensor = None"},{name:"pred_boxes",val:": FloatTensor = None"},{name:"auxiliary_outputs",val:": typing.Optional[typing.List[typing.Dict]] = None"},{name:"last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.loss",description:`<strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) &#x2014;
Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.`,name:"loss"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.loss_dict",description:`<strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary containing the individual losses. Useful for logging.`,name:"loss_dict"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) &#x2014;
Classification logits (including no-object) for all queries.`,name:"logits"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.pred_boxes",description:`<strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) &#x2014;
Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection">post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.`,name:"pred_boxes"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.auxiliary_outputs",description:`<strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) &#x2014;
Optional, only returned when auxilary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.`,name:"auxiliary_outputs"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrObjectDetectionOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L136"}}),lo=new k({props:{name:"class transformers.models.detr.modeling_detr.DetrSegmentationOutput",anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput",parameters:[{name:"loss",val:": typing.Optional[torch.FloatTensor] = None"},{name:"loss_dict",val:": typing.Optional[typing.Dict] = None"},{name:"logits",val:": FloatTensor = None"},{name:"pred_boxes",val:": FloatTensor = None"},{name:"pred_masks",val:": FloatTensor = None"},{name:"auxiliary_outputs",val:": typing.Optional[typing.List[typing.Dict]] = None"},{name:"last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"decoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"decoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"cross_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_last_hidden_state",val:": typing.Optional[torch.FloatTensor] = None"},{name:"encoder_hidden_states",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"},{name:"encoder_attentions",val:": typing.Optional[typing.Tuple[torch.FloatTensor]] = None"}],parametersDescription:[{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.loss",description:`<strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) &#x2014;
Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.`,name:"loss"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.loss_dict",description:`<strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) &#x2014;
A dictionary containing the individual losses. Useful for logging.`,name:"loss_dict"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) &#x2014;
Classification logits (including no-object) for all queries.`,name:"logits"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.pred_boxes",description:`<strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) &#x2014;
Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection">post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.`,name:"pred_boxes"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.pred_masks",description:`<strong>pred_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, height/4, width/4)</code>) &#x2014;
Segmentation masks logits for all queries. See also
<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_semantic_segmentation">post_process_semantic_segmentation()</a> or
<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_instance_segmentation">post_process_instance_segmentation()</a>
<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_panoptic_segmentation">post_process_panoptic_segmentation()</a> to evaluate semantic, instance and panoptic
segmentation masks respectively.`,name:"pred_masks"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.auxiliary_outputs",description:`<strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) &#x2014;
Optional, only returned when auxiliary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.`,name:"auxiliary_outputs"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.last_hidden_state",description:`<strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the decoder of the model.`,name:"last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.decoder_hidden_states",description:`<strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.`,name:"decoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.decoder_attentions",description:`<strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"decoder_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.cross_attentions",description:`<strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder&#x2019;s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.`,name:"cross_attentions"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_last_hidden_state",description:`<strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Sequence of hidden-states at the output of the last layer of the encoder of the model.`,name:"encoder_last_hidden_state"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_hidden_states",description:`<strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.`,name:"encoder_hidden_states"},{anchor:"transformers.models.detr.modeling_detr.DetrSegmentationOutput.encoder_attentions",description:`<strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) &#x2014;
Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.`,name:"encoder_attentions"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L199"}}),mo=new we({}),po=new k({props:{name:"class transformers.DetrConfig",anchor:"transformers.DetrConfig",parameters:[{name:"use_timm_backbone",val:" = True"},{name:"backbone_config",val:" = None"},{name:"num_channels",val:" = 3"},{name:"num_queries",val:" = 100"},{name:"encoder_layers",val:" = 6"},{name:"encoder_ffn_dim",val:" = 2048"},{name:"encoder_attention_heads",val:" = 8"},{name:"decoder_layers",val:" = 6"},{name:"decoder_ffn_dim",val:" = 2048"},{name:"decoder_attention_heads",val:" = 8"},{name:"encoder_layerdrop",val:" = 0.0"},{name:"decoder_layerdrop",val:" = 0.0"},{name:"is_encoder_decoder",val:" = True"},{name:"activation_function",val:" = 'relu'"},{name:"d_model",val:" = 256"},{name:"dropout",val:" = 0.1"},{name:"attention_dropout",val:" = 0.0"},{name:"activation_dropout",val:" = 0.0"},{name:"init_std",val:" = 0.02"},{name:"init_xavier_std",val:" = 1.0"},{name:"classifier_dropout",val:" = 0.0"},{name:"scale_embedding",val:" = False"},{name:"auxiliary_loss",val:" = False"},{name:"position_embedding_type",val:" = 'sine'"},{name:"backbone",val:" = 'resnet50'"},{name:"use_pretrained_backbone",val:" = True"},{name:"dilation",val:" = False"},{name:"class_cost",val:" = 1"},{name:"bbox_cost",val:" = 5"},{name:"giou_cost",val:" = 2"},{name:"mask_loss_coefficient",val:" = 1"},{name:"dice_loss_coefficient",val:" = 1"},{name:"bbox_loss_coefficient",val:" = 5"},{name:"giou_loss_coefficient",val:" = 2"},{name:"eos_coefficient",val:" = 0.1"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrConfig.use_timm_backbone",description:`<strong>use_timm_backbone</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to use the <code>timm</code> library for the backbone. If set to <code>False</code>, will use the <code>AutoBackbone</code>
API.`,name:"use_timm_backbone"},{anchor:"transformers.DetrConfig.backbone_config",description:`<strong>backbone_config</strong> (<code>PretrainedConfig</code> or <code>dict</code>, <em>optional</em>) &#x2014;
The configuration of the backbone model. Only used in case <code>use_timm_backbone</code> is set to <code>False</code> in which
case it will default to <code>ResNetConfig()</code>.`,name:"backbone_config"},{anchor:"transformers.DetrConfig.num_channels",description:`<strong>num_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 3) &#x2014;
The number of input channels.`,name:"num_channels"},{anchor:"transformers.DetrConfig.num_queries",description:`<strong>num_queries</strong> (<code>int</code>, <em>optional</em>, defaults to 100) &#x2014;
Number of object queries, i.e. detection slots. This is the maximal number of objects <a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrModel">DetrModel</a> can
detect in a single image. For COCO, we recommend 100 queries.`,name:"num_queries"},{anchor:"transformers.DetrConfig.d_model",description:`<strong>d_model</strong> (<code>int</code>, <em>optional</em>, defaults to 256) &#x2014;
Dimension of the layers.`,name:"d_model"},{anchor:"transformers.DetrConfig.encoder_layers",description:`<strong>encoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of encoder layers.`,name:"encoder_layers"},{anchor:"transformers.DetrConfig.decoder_layers",description:`<strong>decoder_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 6) &#x2014;
Number of decoder layers.`,name:"decoder_layers"},{anchor:"transformers.DetrConfig.encoder_attention_heads",description:`<strong>encoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"encoder_attention_heads"},{anchor:"transformers.DetrConfig.decoder_attention_heads",description:`<strong>decoder_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 8) &#x2014;
Number of attention heads for each attention layer in the Transformer decoder.`,name:"decoder_attention_heads"},{anchor:"transformers.DetrConfig.decoder_ffn_dim",description:`<strong>decoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"decoder_ffn_dim"},{anchor:"transformers.DetrConfig.encoder_ffn_dim",description:`<strong>encoder_ffn_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 2048) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (often named feed-forward) layer in decoder.`,name:"encoder_ffn_dim"},{anchor:"transformers.DetrConfig.activation_function",description:`<strong>activation_function</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;silu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"activation_function"},{anchor:"transformers.DetrConfig.dropout",description:`<strong>dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probability for all fully connected layers in the embeddings, encoder, and pooler.`,name:"dropout"},{anchor:"transformers.DetrConfig.attention_dropout",description:`<strong>attention_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_dropout"},{anchor:"transformers.DetrConfig.activation_dropout",description:`<strong>activation_dropout</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The dropout ratio for activations inside the fully connected layer.`,name:"activation_dropout"},{anchor:"transformers.DetrConfig.init_std",description:`<strong>init_std</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"init_std"},{anchor:"transformers.DetrConfig.init_xavier_std",description:`<strong>init_xavier_std</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
The scaling factor used for the Xavier initialization gain in the HM Attention map module.`,name:"init_xavier_std"},{anchor:"transformers.DetrConfig.encoder_layerdrop",description:`<strong>encoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the encoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"encoder_layerdrop"},{anchor:"transformers.DetrConfig.decoder_layerdrop",description:`<strong>decoder_layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
The LayerDrop probability for the decoder. See the [LayerDrop paper](see <a href="https://arxiv.org/abs/1909.11556" rel="nofollow">https://arxiv.org/abs/1909.11556</a>)
for more details.`,name:"decoder_layerdrop"},{anchor:"transformers.DetrConfig.auxiliary_loss",description:`<strong>auxiliary_loss</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether auxiliary decoding losses (loss at each decoder layer) are to be used.`,name:"auxiliary_loss"},{anchor:"transformers.DetrConfig.position_embedding_type",description:`<strong>position_embedding_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;sine&quot;</code>) &#x2014;
Type of position embeddings to be used on top of the image features. One of <code>&quot;sine&quot;</code> or <code>&quot;learned&quot;</code>.`,name:"position_embedding_type"},{anchor:"transformers.DetrConfig.backbone",description:`<strong>backbone</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;resnet50&quot;</code>) &#x2014;
Name of convolutional backbone to use in case <code>use_timm_backbone</code> = <code>True</code>. Supports any convolutional
backbone from the timm package. For a list of all available models, see <a href="https://rwightman.github.io/pytorch-image-models/#load-a-pretrained-model" rel="nofollow">this
page</a>.`,name:"backbone"},{anchor:"transformers.DetrConfig.use_pretrained_backbone",description:`<strong>use_pretrained_backbone</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to use pretrained weights for the backbone. Only supported when <code>use_timm_backbone</code> = <code>True</code>.`,name:"use_pretrained_backbone"},{anchor:"transformers.DetrConfig.dilation",description:`<strong>dilation</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to replace stride with dilation in the last convolutional block (DC5). Only supported when
<code>use_timm_backbone</code> = <code>True</code>.`,name:"dilation"},{anchor:"transformers.DetrConfig.class_cost",description:`<strong>class_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the classification error in the Hungarian matching cost.`,name:"class_cost"},{anchor:"transformers.DetrConfig.bbox_cost",description:`<strong>bbox_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 error of the bounding box coordinates in the Hungarian matching cost.`,name:"bbox_cost"},{anchor:"transformers.DetrConfig.giou_cost",description:`<strong>giou_cost</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss of the bounding box in the Hungarian matching cost.`,name:"giou_cost"},{anchor:"transformers.DetrConfig.mask_loss_coefficient",description:`<strong>mask_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the Focal loss in the panoptic segmentation loss.`,name:"mask_loss_coefficient"},{anchor:"transformers.DetrConfig.dice_loss_coefficient",description:`<strong>dice_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Relative weight of the DICE/F-1 loss in the panoptic segmentation loss.`,name:"dice_loss_coefficient"},{anchor:"transformers.DetrConfig.bbox_loss_coefficient",description:`<strong>bbox_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 5) &#x2014;
Relative weight of the L1 bounding box loss in the object detection loss.`,name:"bbox_loss_coefficient"},{anchor:"transformers.DetrConfig.giou_loss_coefficient",description:`<strong>giou_loss_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 2) &#x2014;
Relative weight of the generalized IoU loss in the object detection loss.`,name:"giou_loss_coefficient"},{anchor:"transformers.DetrConfig.eos_coefficient",description:`<strong>eos_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
Relative classification weight of the &#x2018;no-object&#x2019; class in the object detection loss.`,name:"eos_coefficient"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/configuration_detr.py#L36"}}),Je=new od({props:{anchor:"transformers.DetrConfig.example",$$slots:{default:[Zb]},$$scope:{ctx:I}}}),uo=new we({}),go=new k({props:{name:"class transformers.DetrImageProcessor",anchor:"transformers.DetrImageProcessor",parameters:[{name:"format",val:": typing.Union[str, transformers.models.detr.image_processing_detr.AnnotionFormat] = <AnnotionFormat.COCO_DETECTION: 'coco_detection'>"},{name:"do_resize",val:": bool = True"},{name:"size",val:": typing.Dict[str, int] = None"},{name:"resample",val:": Resampling = <Resampling.BILINEAR: 2>"},{name:"do_rescale",val:": bool = True"},{name:"rescale_factor",val:": typing.Union[int, float] = 0.00392156862745098"},{name:"do_normalize",val:": bool = True"},{name:"image_mean",val:": typing.Union[float, typing.List[float]] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float]] = None"},{name:"do_pad",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.format",description:`<strong>format</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;coco_detection&quot;</code>) &#x2014;
Data format of the annotations. One of &#x201C;coco_detection&#x201D; or &#x201C;coco_panoptic&#x201D;.`,name:"format"},{anchor:"transformers.DetrImageProcessor.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to resize the image&#x2019;s <code>(height, width)</code> dimensions to the specified <code>size</code>. Can be
overridden by the <code>do_resize</code> parameter in the <code>preprocess</code> method.`,name:"do_resize"},{anchor:"transformers.DetrImageProcessor.size",description:`<strong>size</strong> (<code>Dict[str, int]</code> <em>optional</em>, defaults to <code>{&quot;shortest_edge&quot; -- 800, &quot;longest_edge&quot;: 1333}</code>):
Size of the image&#x2019;s <code>(height, width)</code> dimensions after resizing. Can be overridden by the <code>size</code> parameter
in the <code>preprocess</code> method.`,name:"size"},{anchor:"transformers.DetrImageProcessor.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to <code>PILImageResampling.BILINEAR</code>) &#x2014;
Resampling filter to use if resizing the image.`,name:"resample"},{anchor:"transformers.DetrImageProcessor.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to rescale the image by the specified scale <code>rescale_factor</code>. Can be overridden by the
<code>do_rescale</code> parameter in the <code>preprocess</code> method.`,name:"do_rescale"},{anchor:"transformers.DetrImageProcessor.rescale_factor",description:`<strong>rescale_factor</strong> (<code>int</code> or <code>float</code>, <em>optional</em>, defaults to <code>1/255</code>) &#x2014;
Scale factor to use if rescaling the image. Can be overridden by the <code>rescale_factor</code> parameter in the
<code>preprocess</code> method.
do_normalize &#x2014;
Controls whether to normalize the image. Can be overridden by the <code>do_normalize</code> parameter in the
<code>preprocess</code> method.`,name:"rescale_factor"},{anchor:"transformers.DetrImageProcessor.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_MEAN</code>) &#x2014;
Mean values to use when normalizing the image. Can be a single value or a list of values, one for each
channel. Can be overridden by the <code>image_mean</code> parameter in the <code>preprocess</code> method.`,name:"image_mean"},{anchor:"transformers.DetrImageProcessor.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to <code>IMAGENET_DEFAULT_STD</code>) &#x2014;
Standard deviation values to use when normalizing the image. Can be a single value or a list of values, one
for each channel. Can be overridden by the <code>image_std</code> parameter in the <code>preprocess</code> method.`,name:"image_std"},{anchor:"transformers.DetrImageProcessor.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Controls whether to pad the image to the largest image in a batch and create a pixel mask. Can be
overridden by the <code>do_pad</code> parameter in the <code>preprocess</code> method.`,name:"do_pad"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L721"}}),_o=new k({props:{name:"preprocess",anchor:"transformers.DetrImageProcessor.preprocess",parameters:[{name:"images",val:": typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]"},{name:"annotations",val:": typing.Union[typing.List[typing.Dict], typing.List[typing.List[typing.Dict]], NoneType] = None"},{name:"return_segmentation_masks",val:": bool = None"},{name:"masks_path",val:": typing.Union[str, pathlib.Path, NoneType] = None"},{name:"do_resize",val:": typing.Optional[bool] = None"},{name:"size",val:": typing.Union[typing.Dict[str, int], NoneType] = None"},{name:"resample",val:" = None"},{name:"do_rescale",val:": typing.Optional[bool] = None"},{name:"rescale_factor",val:": typing.Union[int, float, NoneType] = None"},{name:"do_normalize",val:": typing.Optional[bool] = None"},{name:"image_mean",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"image_std",val:": typing.Union[float, typing.List[float], NoneType] = None"},{name:"do_pad",val:": typing.Optional[bool] = None"},{name:"format",val:": typing.Union[str, transformers.models.detr.image_processing_detr.AnnotionFormat, NoneType] = None"},{name:"return_tensors",val:": typing.Union[transformers.utils.generic.TensorType, str, NoneType] = None"},{name:"data_format",val:": typing.Union[str, transformers.image_utils.ChannelDimension] = <ChannelDimension.FIRST: 'channels_first'>"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.preprocess.images",description:`<strong>images</strong> (<code>ImageInput</code>) &#x2014;
Image or batch of images to preprocess.`,name:"images"},{anchor:"transformers.DetrImageProcessor.preprocess.annotations",description:`<strong>annotations</strong> (<code>List[Dict]</code> or <code>List[List[Dict]]</code>, <em>optional</em>) &#x2014;
List of annotations associated with the image or batch of images. If annotionation is for object
detection, the annotations should be a dictionary with the following keys:<ul>
<li>&#x201C;image_id&#x201D; (<code>int</code>): The image id.</li>
<li>&#x201C;annotations&#x201D; (<code>List[Dict]</code>): List of annotations for an image. Each annotation should be a
dictionary. An image can have no annotations, in which case the list should be empty.
If annotionation is for segmentation, the annotations should be a dictionary with the following keys:</li>
<li>&#x201C;image_id&#x201D; (<code>int</code>): The image id.</li>
<li>&#x201C;segments_info&#x201D; (<code>List[Dict]</code>): List of segments for an image. Each segment should be a dictionary.
An image can have no segments, in which case the list should be empty.</li>
<li>&#x201C;file_name&#x201D; (<code>str</code>): The file name of the image.</li>
</ul>`,name:"annotations"},{anchor:"transformers.DetrImageProcessor.preprocess.return_segmentation_masks",description:`<strong>return_segmentation_masks</strong> (<code>bool</code>, <em>optional</em>, defaults to self.return_segmentation_masks) &#x2014;
Whether to return segmentation masks.`,name:"return_segmentation_masks"},{anchor:"transformers.DetrImageProcessor.preprocess.masks_path",description:`<strong>masks_path</strong> (<code>str</code> or <code>pathlib.Path</code>, <em>optional</em>) &#x2014;
Path to the directory containing the segmentation masks.`,name:"masks_path"},{anchor:"transformers.DetrImageProcessor.preprocess.do_resize",description:`<strong>do_resize</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_resize) &#x2014;
Whether to resize the image.`,name:"do_resize"},{anchor:"transformers.DetrImageProcessor.preprocess.size",description:`<strong>size</strong> (<code>Dict[str, int]</code>, <em>optional</em>, defaults to self.size) &#x2014;
Size of the image after resizing.`,name:"size"},{anchor:"transformers.DetrImageProcessor.preprocess.resample",description:`<strong>resample</strong> (<code>PILImageResampling</code>, <em>optional</em>, defaults to self.resample) &#x2014;
Resampling filter to use when resizing the image.`,name:"resample"},{anchor:"transformers.DetrImageProcessor.preprocess.do_rescale",description:`<strong>do_rescale</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_rescale) &#x2014;
Whether to rescale the image.`,name:"do_rescale"},{anchor:"transformers.DetrImageProcessor.preprocess.rescale_factor",description:`<strong>rescale_factor</strong> (<code>float</code>, <em>optional</em>, defaults to self.rescale_factor) &#x2014;
Rescale factor to use when rescaling the image.`,name:"rescale_factor"},{anchor:"transformers.DetrImageProcessor.preprocess.do_normalize",description:`<strong>do_normalize</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_normalize) &#x2014;
Whether to normalize the image.`,name:"do_normalize"},{anchor:"transformers.DetrImageProcessor.preprocess.image_mean",description:`<strong>image_mean</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to self.image_mean) &#x2014;
Mean to use when normalizing the image.`,name:"image_mean"},{anchor:"transformers.DetrImageProcessor.preprocess.image_std",description:`<strong>image_std</strong> (<code>float</code> or <code>List[float]</code>, <em>optional</em>, defaults to self.image_std) &#x2014;
Standard deviation to use when normalizing the image.`,name:"image_std"},{anchor:"transformers.DetrImageProcessor.preprocess.do_pad",description:`<strong>do_pad</strong> (<code>bool</code>, <em>optional</em>, defaults to self.do_pad) &#x2014;
Whether to pad the image.`,name:"do_pad"},{anchor:"transformers.DetrImageProcessor.preprocess.format",description:`<strong>format</strong> (<code>str</code> or <code>AnnotionFormat</code>, <em>optional</em>, defaults to self.format) &#x2014;
Format of the annotations.`,name:"format"},{anchor:"transformers.DetrImageProcessor.preprocess.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>, defaults to self.return_tensors) &#x2014;
Type of tensors to return. If <code>None</code>, will return the list of images.`,name:"return_tensors"},{anchor:"transformers.DetrImageProcessor.preprocess.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>, defaults to self.data_format) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1037"}}),bo=new k({props:{name:"post_process_object_detection",anchor:"transformers.DetrImageProcessor.post_process_object_detection",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"target_sizes",val:": typing.Union[transformers.utils.generic.TensorType, typing.List[typing.Tuple]] = None"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_object_detection.outputs",description:`<strong>outputs</strong> (<code>DetrObjectDetectionOutput</code>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_object_detection.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Score threshold to keep object detection predictions.`,name:"threshold"},{anchor:"transformers.DetrImageProcessor.post_process_object_detection.target_sizes",description:`<strong>target_sizes</strong> (<code>torch.Tensor</code> or <code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
Tensor of shape <code>(batch_size, 2)</code> or list of tuples (<code>Tuple[int, int]</code>) containing the target size
<code>(height, width)</code> of each image in the batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1521",returnDescription:`
<p>A list of dictionaries, each dictionary containing the scores, labels and boxes for an image
in the batch as predicted by the model.</p>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),yo=new k({props:{name:"post_process_semantic_segmentation",anchor:"transformers.DetrImageProcessor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.List[typing.Tuple[int, int]] = None"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
A list of tuples (<code>Tuple[int, int]</code>) containing the target size (height, width) of each image in the
batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1574",returnDescription:`
<p>A list of length <code>batch_size</code>, where each item is a semantic segmentation map of shape (height, width)
corresponding to the target_sizes entry (if <code>target_sizes</code> is specified). Each entry of each
<code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p><code>List[torch.Tensor]</code></p>
`}}),wo=new k({props:{name:"post_process_instance_segmentation",anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"},{name:"return_coco_annotation",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If unset, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.DetrImageProcessor.post_process_instance_segmentation.return_coco_annotation",description:`<strong>return_coco_annotation</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Defaults to <code>False</code>. If set to <code>True</code>, segmentation maps are returned in COCO run-length encoding (RLE)
format.`,name:"return_coco_annotation"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1622",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 A tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>List[List]</code> run-length encoding (RLE) of the segmentation map if return_coco_annotation is set to
<code>True</code>. Set to <code>None</code> if no mask if found above <code>threshold</code>.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 An integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),xo=new k({props:{name:"post_process_panoptic_segmentation",anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"label_ids_to_fuse",val:": typing.Optional[typing.Set[int]] = None"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"}],parametersDescription:[{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
The outputs from <a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>.`,name:"outputs"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.label_ids_to_fuse",description:`<strong>label_ids_to_fuse</strong> (<code>Set[int]</code>, <em>optional</em>) &#x2014;
The labels in this state will have all their instances be fused together. For instance we could say
there can only be one sky in an image, but several persons, so the label ID for sky would be in that
set, but not the one for person.`,name:"label_ids_to_fuse"},{anchor:"transformers.DetrImageProcessor.post_process_panoptic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction in batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1706",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 a tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>None</code> if no mask if found above <code>threshold</code>. If <code>target_sizes</code> is specified, segmentation is resized to
the corresponding <code>target_sizes</code> entry.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 an integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>was_fused</strong> \u2014 a boolean, <code>True</code> if <code>label_id</code> was in <code>label_ids_to_fuse</code>, <code>False</code> otherwise.
Multiple instances of the same class / label were fused and assigned a single <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),$o=new we({}),ko=new k({props:{name:"class transformers.DetrFeatureExtractor",anchor:"transformers.DetrFeatureExtractor",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/feature_extraction_detr.py#L26"}}),Fo=new k({props:{name:"__call__",anchor:"transformers.DetrFeatureExtractor.__call__",parameters:[{name:"images",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/image_processing_utils.py#L444"}}),jo=new k({props:{name:"pad_and_create_pixel_mask",anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask",parameters:[{name:"pixel_values_list",val:": typing.List[typing.Union[ForwardRef('PIL.Image.Image'), numpy.ndarray, ForwardRef('torch.Tensor'), typing.List[ForwardRef('PIL.Image.Image')], typing.List[numpy.ndarray], typing.List[ForwardRef('torch.Tensor')]]]"},{name:"return_tensors",val:": typing.Union[transformers.utils.generic.TensorType, str, NoneType] = None"},{name:"data_format",val:": typing.Optional[transformers.image_utils.ChannelDimension] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.images",description:`<strong>images</strong> (<code>List[np.ndarray]</code>) &#x2014;
Batch of images to pad.`,name:"images"},{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <code>TensorType</code>, <em>optional</em>) &#x2014;
The type of tensors to return. Can be one of:<ul>
<li>Unset: Return a list of <code>np.ndarray</code>.</li>
<li><code>TensorType.TENSORFLOW</code> or <code>&apos;tf&apos;</code>: Return a batch of type <code>tf.Tensor</code>.</li>
<li><code>TensorType.PYTORCH</code> or <code>&apos;pt&apos;</code>: Return a batch of type <code>torch.Tensor</code>.</li>
<li><code>TensorType.NUMPY</code> or <code>&apos;np&apos;</code>: Return a batch of type <code>np.ndarray</code>.</li>
<li><code>TensorType.JAX</code> or <code>&apos;jax&apos;</code>: Return a batch of type <code>jax.numpy.ndarray</code>.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.DetrFeatureExtractor.pad_and_create_pixel_mask.data_format",description:`<strong>data_format</strong> (<code>str</code> or <code>ChannelDimension</code>, <em>optional</em>) &#x2014;
The channel dimension format of the image. If not provided, it will be the same as the input image.`,name:"data_format"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L943"}}),Oo=new k({props:{name:"post_process_object_detection",anchor:"transformers.DetrFeatureExtractor.post_process_object_detection",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"target_sizes",val:": typing.Union[transformers.utils.generic.TensorType, typing.List[typing.Tuple]] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.outputs",description:`<strong>outputs</strong> (<code>DetrObjectDetectionOutput</code>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>) &#x2014;
Score threshold to keep object detection predictions.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_object_detection.target_sizes",description:`<strong>target_sizes</strong> (<code>torch.Tensor</code> or <code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
Tensor of shape <code>(batch_size, 2)</code> or list of tuples (<code>Tuple[int, int]</code>) containing the target size
<code>(height, width)</code> of each image in the batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1521",returnDescription:`
<p>A list of dictionaries, each dictionary containing the scores, labels and boxes for an image
in the batch as predicted by the model.</p>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),Co=new k({props:{name:"post_process_semantic_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation",parameters:[{name:"outputs",val:""},{name:"target_sizes",val:": typing.List[typing.Tuple[int, int]] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_semantic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple[int, int]]</code>, <em>optional</em>) &#x2014;
A list of tuples (<code>Tuple[int, int]</code>) containing the target size (height, width) of each image in the
batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1574",returnDescription:`
<p>A list of length <code>batch_size</code>, where each item is a semantic segmentation map of shape (height, width)
corresponding to the target_sizes entry (if <code>target_sizes</code> is specified). Each entry of each
<code>torch.Tensor</code> correspond to a semantic class id.</p>
`,returnType:`
<p><code>List[torch.Tensor]</code></p>
`}}),qo=new k({props:{name:"post_process_instance_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"},{name:"return_coco_annotation",val:": typing.Optional[bool] = False"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
Raw outputs of the model.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction. If unset, predictions will not be resized.`,name:"target_sizes"},{anchor:"transformers.DetrFeatureExtractor.post_process_instance_segmentation.return_coco_annotation",description:`<strong>return_coco_annotation</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Defaults to <code>False</code>. If set to <code>True</code>, segmentation maps are returned in COCO run-length encoding (RLE)
format.`,name:"return_coco_annotation"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1622",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 A tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>List[List]</code> run-length encoding (RLE) of the segmentation map if return_coco_annotation is set to
<code>True</code>. Set to <code>None</code> if no mask if found above <code>threshold</code>.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 An integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),No=new k({props:{name:"post_process_panoptic_segmentation",anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation",parameters:[{name:"outputs",val:""},{name:"threshold",val:": float = 0.5"},{name:"mask_threshold",val:": float = 0.5"},{name:"overlap_mask_area_threshold",val:": float = 0.8"},{name:"label_ids_to_fuse",val:": typing.Optional[typing.Set[int]] = None"},{name:"target_sizes",val:": typing.Union[typing.List[typing.Tuple[int, int]], NoneType] = None"}],parametersDescription:[{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.outputs",description:`<strong>outputs</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>) &#x2014;
The outputs from <a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation">DetrForSegmentation</a>.`,name:"outputs"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.threshold",description:`<strong>threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
The probability score threshold to keep predicted instance masks.`,name:"threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.mask_threshold",description:`<strong>mask_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.5) &#x2014;
Threshold to use when turning the predicted masks into binary values.`,name:"mask_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.overlap_mask_area_threshold",description:`<strong>overlap_mask_area_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to 0.8) &#x2014;
The overlap mask area threshold to merge or discard small disconnected parts within each binary
instance mask.`,name:"overlap_mask_area_threshold"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.label_ids_to_fuse",description:`<strong>label_ids_to_fuse</strong> (<code>Set[int]</code>, <em>optional</em>) &#x2014;
The labels in this state will have all their instances be fused together. For instance we could say
there can only be one sky in an image, but several persons, so the label ID for sky would be in that
set, but not the one for person.`,name:"label_ids_to_fuse"},{anchor:"transformers.DetrFeatureExtractor.post_process_panoptic_segmentation.target_sizes",description:`<strong>target_sizes</strong> (<code>List[Tuple]</code>, <em>optional</em>) &#x2014;
List of length (batch_size), where each list item (<code>Tuple[int, int]]</code>) corresponds to the requested
final size (height, width) of each prediction in batch. If unset, predictions will not be resized.`,name:"target_sizes"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/image_processing_detr.py#L1706",returnDescription:`
<p>A list of dictionaries, one per image, each dictionary containing two keys:</p>
<ul>
<li><strong>segmentation</strong> \u2014 a tensor of shape <code>(height, width)</code> where each pixel represents a <code>segment_id</code> or
<code>None</code> if no mask if found above <code>threshold</code>. If <code>target_sizes</code> is specified, segmentation is resized to
the corresponding <code>target_sizes</code> entry.</li>
<li><strong>segments_info</strong> \u2014 A dictionary that contains additional information on each segment.<ul>
<li><strong>id</strong> \u2014 an integer representing the <code>segment_id</code>.</li>
<li><strong>label_id</strong> \u2014 An integer representing the label / semantic class id corresponding to <code>segment_id</code>.</li>
<li><strong>was_fused</strong> \u2014 a boolean, <code>True</code> if <code>label_id</code> was in <code>label_ids_to_fuse</code>, <code>False</code> otherwise.
Multiple instances of the same class / label were fused and assigned a single <code>segment_id</code>.</li>
<li><strong>score</strong> \u2014 Prediction score of segment with <code>segment_id</code>.</li>
</ul></li>
</ul>
`,returnType:`
<p><code>List[Dict]</code></p>
`}}),So=new we({}),Lo=new k({props:{name:"class transformers.DetrModel",anchor:"transformers.DetrModel",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L1201"}}),Ho=new k({props:{name:"forward",anchor:"transformers.DetrModel.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrModel.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <a href="/docs/transformers/v4.26.0/en/model_doc/poolformer#transformers.PoolFormerFeatureExtractor.__call__">DetrImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.DetrModel.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrModel.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrModel.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrModel.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrModel.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L1235",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrModelOutput"
>transformers.models.detr.modeling_detr.DetrModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>intermediate_hidden_states</strong> (<code>torch.FloatTensor</code> of shape <code>(config.decoder_layers, batch_size, sequence_length, hidden_size)</code>, <em>optional</em>, returned when <code>config.auxiliary_loss=True</code>) \u2014 Intermediate decoder activations, i.e. the output of each decoder layer, each of them gone through a
layernorm.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrModelOutput"
>transformers.models.detr.modeling_detr.DetrModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ht=new Tu({props:{$$slots:{default:[ev]},$$scope:{ctx:I}}}),mt=new od({props:{anchor:"transformers.DetrModel.forward.example",$$slots:{default:[tv]},$$scope:{ctx:I}}}),Go=new we({}),Wo=new k({props:{name:"class transformers.DetrForObjectDetection",anchor:"transformers.DetrForObjectDetection",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrForObjectDetection.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L1369"}}),Qo=new k({props:{name:"forward",anchor:"transformers.DetrForObjectDetection.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"labels",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrForObjectDetection.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <a href="/docs/transformers/v4.26.0/en/model_doc/poolformer#transformers.PoolFormerFeatureExtractor.__call__">DetrImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.DetrForObjectDetection.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrForObjectDetection.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrForObjectDetection.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrForObjectDetection.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrForObjectDetection.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrForObjectDetection.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrForObjectDetection.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrForObjectDetection.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DetrForObjectDetection.forward.labels",description:`<strong>labels</strong> (<code>List[Dict]</code> of len <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the bipartite matching loss. List of dicts, each dictionary containing at least the
following 2 keys: &#x2018;class_labels&#x2019; and &#x2018;boxes&#x2019; (the class labels and bounding boxes of an image in the batch
respectively). The class labels themselves should be a <code>torch.LongTensor</code> of len <code>(number of bounding boxes in the image,)</code> and the boxes a <code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, 4)</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L1395",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrObjectDetectionOutput"
>transformers.models.detr.modeling_detr.DetrObjectDetectionOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) \u2014 Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.</li>
<li><strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) \u2014 A dictionary containing the individual losses. Useful for logging.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) \u2014 Classification logits (including no-object) for all queries.</li>
<li><strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) \u2014 Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection"
>post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.</li>
<li><strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) \u2014 Optional, only returned when auxilary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrObjectDetectionOutput"
>transformers.models.detr.modeling_detr.DetrObjectDetectionOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),ft=new Tu({props:{$$slots:{default:[ov]},$$scope:{ctx:I}}}),ut=new od({props:{anchor:"transformers.DetrForObjectDetection.forward.example",$$slots:{default:[nv]},$$scope:{ctx:I}}}),Jo=new we({}),Ko=new k({props:{name:"class transformers.DetrForSegmentation",anchor:"transformers.DetrForSegmentation",parameters:[{name:"config",val:": DetrConfig"}],parametersDescription:[{anchor:"transformers.DetrForSegmentation.config",description:`<strong>config</strong> (<a href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig">DetrConfig</a>) &#x2014;
Model configuration class with all the parameters of the model. Initializing with a config file does not
load the weights associated with the model, only the configuration. Check out the
<a href="/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L1543"}}),tn=new k({props:{name:"forward",anchor:"transformers.DetrForSegmentation.forward",parameters:[{name:"pixel_values",val:""},{name:"pixel_mask",val:" = None"},{name:"decoder_attention_mask",val:" = None"},{name:"encoder_outputs",val:" = None"},{name:"inputs_embeds",val:" = None"},{name:"decoder_inputs_embeds",val:" = None"},{name:"labels",val:" = None"},{name:"output_attentions",val:" = None"},{name:"output_hidden_states",val:" = None"},{name:"return_dict",val:" = None"}],parametersDescription:[{anchor:"transformers.DetrForSegmentation.forward.pixel_values",description:`<strong>pixel_values</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_channels, height, width)</code>) &#x2014;
Pixel values. Padding will be ignored by default should you provide it.</p>
<p>Pixel values can be obtained using <a href="/docs/transformers/v4.26.0/en/model_doc/auto#transformers.AutoImageProcessor">AutoImageProcessor</a>. See <a href="/docs/transformers/v4.26.0/en/model_doc/poolformer#transformers.PoolFormerFeatureExtractor.__call__">DetrImageProcessor.<strong>call</strong>()</a> for details.`,name:"pixel_values"},{anchor:"transformers.DetrForSegmentation.forward.pixel_mask",description:`<strong>pixel_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, height, width)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding pixel values. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for pixels that are real (i.e. <strong>not masked</strong>),</li>
<li>0 for pixels that are padding (i.e. <strong>masked</strong>).</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"pixel_mask"},{anchor:"transformers.DetrForSegmentation.forward.decoder_attention_mask",description:`<strong>decoder_attention_mask</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, num_queries)</code>, <em>optional</em>) &#x2014;
Not used by default. Can be used to mask object queries.`,name:"decoder_attention_mask"},{anchor:"transformers.DetrForSegmentation.forward.encoder_outputs",description:`<strong>encoder_outputs</strong> (<code>tuple(tuple(torch.FloatTensor)</code>, <em>optional</em>) &#x2014;
Tuple consists of (<code>last_hidden_state</code>, <em>optional</em>: <code>hidden_states</code>, <em>optional</em>: <code>attentions</code>)
<code>last_hidden_state</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) is a sequence of
hidden-states at the output of the last layer of the encoder. Used in the cross-attention of the decoder.`,name:"encoder_outputs"},{anchor:"transformers.DetrForSegmentation.forward.inputs_embeds",description:`<strong>inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of passing the flattened feature map (output of the backbone + projection layer), you
can choose to directly pass a flattened representation of an image.`,name:"inputs_embeds"},{anchor:"transformers.DetrForSegmentation.forward.decoder_inputs_embeds",description:`<strong>decoder_inputs_embeds</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, hidden_size)</code>, <em>optional</em>) &#x2014;
Optionally, instead of initializing the queries with a tensor of zeros, you can choose to directly pass an
embedded representation.`,name:"decoder_inputs_embeds"},{anchor:"transformers.DetrForSegmentation.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.DetrForSegmentation.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.DetrForSegmentation.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/v4.26.0/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.DetrForSegmentation.forward.labels",description:`<strong>labels</strong> (<code>List[Dict]</code> of len <code>(batch_size,)</code>, <em>optional</em>) &#x2014;
Labels for computing the bipartite matching loss, DICE/F-1 loss and Focal loss. List of dicts, each
dictionary containing at least the following 3 keys: &#x2018;class_labels&#x2019;, &#x2018;boxes&#x2019; and &#x2018;masks&#x2019; (the class labels,
bounding boxes and segmentation masks of an image in the batch respectively). The class labels themselves
should be a <code>torch.LongTensor</code> of len <code>(number of bounding boxes in the image,)</code>, the boxes a
<code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, 4)</code> and the masks a
<code>torch.FloatTensor</code> of shape <code>(number of bounding boxes in the image, height, width)</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/v4.26.0/src/transformers/models/detr/modeling_detr.py#L1565",returnDescription:`
<p>A <a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrSegmentationOutput"
>transformers.models.detr.modeling_detr.DetrSegmentationOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig"
>DetrConfig</a>) and inputs.</p>
<ul>
<li><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> are provided)) \u2014 Total loss as a linear combination of a negative log-likehood (cross-entropy) for class prediction and a
bounding box loss. The latter is defined as a linear combination of the L1 loss and the generalized
scale-invariant IoU loss.</li>
<li><strong>loss_dict</strong> (<code>Dict</code>, <em>optional</em>) \u2014 A dictionary containing the individual losses. Useful for logging.</li>
<li><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, num_classes + 1)</code>) \u2014 Classification logits (including no-object) for all queries.</li>
<li><strong>pred_boxes</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, 4)</code>) \u2014 Normalized boxes coordinates for all queries, represented as (center_x, center_y, width, height). These
values are normalized in [0, 1], relative to the size of each individual image in the batch (disregarding
possible padding). You can use <a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_object_detection"
>post_process_object_detection()</a> to retrieve the
unnormalized bounding boxes.</li>
<li><strong>pred_masks</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, num_queries, height/4, width/4)</code>) \u2014 Segmentation masks logits for all queries. See also
<a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_semantic_segmentation"
>post_process_semantic_segmentation()</a> or
<a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_instance_segmentation"
>post_process_instance_segmentation()</a>
<a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.post_process_panoptic_segmentation"
>post_process_panoptic_segmentation()</a> to evaluate semantic, instance and panoptic
segmentation masks respectively.</li>
<li><strong>auxiliary_outputs</strong> (<code>list[Dict]</code>, <em>optional</em>) \u2014 Optional, only returned when auxiliary losses are activated (i.e. <code>config.auxiliary_loss</code> is set to <code>True</code>)
and labels are provided. It is a list of dictionaries containing the two above keys (<code>logits</code> and
<code>pred_boxes</code>) for each decoder layer.</li>
<li><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the decoder of the model.</li>
<li><strong>decoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the decoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>decoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
<li><strong>cross_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the decoder\u2019s cross-attention layer, after the attention softmax,
used to compute the weighted average in the cross-attention heads.</li>
<li><strong>encoder_last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>, <em>optional</em>) \u2014 Sequence of hidden-states at the output of the last layer of the encoder of the model.</li>
<li><strong>encoder_hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings + one for the output of each layer) of
shape <code>(batch_size, sequence_length, hidden_size)</code>. Hidden-states of the encoder at the output of each
layer plus the initial embedding outputs.</li>
<li><strong>encoder_attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>. Attentions weights of the encoder, after the attention softmax, used to compute the
weighted average in the self-attention heads.</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/v4.26.0/en/model_doc/detr#transformers.models.detr.modeling_detr.DetrSegmentationOutput"
>transformers.models.detr.modeling_detr.DetrSegmentationOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),_t=new Tu({props:{$$slots:{default:[rv]},$$scope:{ctx:I}}}),bt=new od({props:{anchor:"transformers.DetrForSegmentation.forward.example",$$slots:{default:[sv]},$$scope:{ctx:I}}}),{c(){f=s("meta"),E=d(),T=s("h1"),u=s("a"),x=s("span"),_(p.$$.fragment),g=d(),H=s("span"),rd=n("DETR"),wa=d(),Te=s("h2"),He=s("a"),mr=s("span"),_(Lt.$$.fragment),sd=d(),pr=s("span"),ad=n("Overview"),Ta=d(),Ge=s("p"),id=n("The DETR model was proposed in "),Rt=s("a"),dd=n("End-to-End Object Detection with Transformers"),cd=n(` by
Nicolas Carion, Francisco Massa, Gabriel Synnaeve, Nicolas Usunier, Alexander Kirillov and Sergey Zagoruyko. DETR
consists of a convolutional backbone followed by an encoder-decoder Transformer which can be trained end-to-end for
object detection. It greatly simplifies a lot of the complexity of models like Faster-R-CNN and Mask-R-CNN, which use
things like region proposals, non-maximum suppression procedure and anchor generation. Moreover, DETR can also be
naturally extended to perform panoptic segmentation, by simply adding a mask head on top of the decoder outputs.`),xa=d(),sn=s("p"),ld=n("The abstract from the paper is the following:"),Ea=d(),an=s("p"),fr=s("em"),hd=n(`We present a new method that views object detection as a direct set prediction problem. Our approach streamlines the
detection pipeline, effectively removing the need for many hand-designed components like a non-maximum suppression
procedure or anchor generation that explicitly encode our prior knowledge about the task. The main ingredients of the
new framework, called DEtection TRansformer or DETR, are a set-based global loss that forces unique predictions via
bipartite matching, and a transformer encoder-decoder architecture. Given a fixed small set of learned object queries,
DETR reasons about the relations of the objects and the global image context to directly output the final set of
predictions in parallel. The new model is conceptually simple and does not require a specialized library, unlike many
other modern detectors. DETR demonstrates accuracy and run-time performance on par with the well-established and
highly-optimized Faster RCNN baseline on the challenging COCO object detection dataset. Moreover, DETR can be easily
generalized to produce panoptic segmentation in a unified manner. We show that it significantly outperforms competitive
baselines.`),$a=d(),_e=s("p"),md=n("This model was contributed by "),Mt=s("a"),pd=n("nielsr"),fd=n(". The original code can be found "),Ut=s("a"),ud=n("here"),gd=n("."),ka=d(),We=s("p"),_d=n("Here\u2019s a TLDR explaining how "),dn=s("a"),bd=n("DetrForObjectDetection"),vd=n(" works:"),Fa=d(),F=s("p"),yd=n(`First, an image is sent through a pre-trained convolutional backbone (in the paper, the authors use
ResNet-50/ResNet-101). Let\u2019s assume we also add a batch dimension. This means that the input to the backbone is a
tensor of shape `),ur=s("code"),Dd=n("(batch_size, 3, height, width)"),wd=n(`, assuming the image has 3 color channels (RGB). The CNN backbone
outputs a new lower-resolution feature map, typically of shape `),gr=s("code"),Td=n("(batch_size, 2048, height/32, width/32)"),xd=n(`. This is
then projected to match the hidden dimension of the Transformer of DETR, which is `),_r=s("code"),Ed=n("256"),$d=n(` by default, using a
`),br=s("code"),kd=n("nn.Conv2D"),Fd=n(" layer. So now, we have a tensor of shape "),vr=s("code"),jd=n("(batch_size, 256, height/32, width/32)."),Od=n(` Next, the
feature map is flattened and transposed to obtain a tensor of shape `),yr=s("code"),zd=n("(batch_size, seq_len, d_model)"),Cd=n(` =
`),Dr=s("code"),Pd=n("(batch_size, width/32*height/32, 256)"),qd=n(`. So a difference with NLP models is that the sequence length is actually
longer than usual, but with a smaller `),wr=s("code"),Id=n("d_model"),Nd=n(" (which in NLP is typically 768 or higher)."),ja=d(),P=s("p"),Ad=n("Next, this is sent through the encoder, outputting "),Tr=s("code"),Sd=n("encoder_hidden_states"),Ld=n(` of the same shape (you can consider
these as image features). Next, so-called `),xr=s("strong"),Rd=n("object queries"),Md=n(` are sent through the decoder. This is a tensor of shape
`),Er=s("code"),Ud=n("(batch_size, num_queries, d_model)"),Hd=n(", with "),$r=s("code"),Gd=n("num_queries"),Wd=n(` typically set to 100 and initialized with zeros.
These input embeddings are learnt positional encodings that the authors refer to as object queries, and similarly to
the encoder, they are added to the input of each attention layer. Each object query will look for a particular object
in the image. The decoder updates these embeddings through multiple self-attention and encoder-decoder attention layers
to output `),kr=s("code"),Vd=n("decoder_hidden_states"),Bd=n(" of the same shape: "),Fr=s("code"),Yd=n("(batch_size, num_queries, d_model)"),Qd=n(`. Next, two heads
are added on top for object detection: a linear layer for classifying each object query into one of the objects or \u201Cno
object\u201D, and a MLP to predict bounding boxes for each query.`),Oa=d(),J=s("p"),Jd=n("The model is trained using a "),jr=s("strong"),Kd=n("bipartite matching loss"),Xd=n(`: so what we actually do is compare the predicted classes +
bounding boxes of each of the N = 100 object queries to the ground truth annotations, padded up to the same length N
(so if an image only contains 4 objects, 96 annotations will just have a \u201Cno object\u201D as class and \u201Cno bounding box\u201D as
bounding box). The `),Ht=s("a"),Zd=n("Hungarian matching algorithm"),ec=n(` is used to find
an optimal one-to-one mapping of each of the N queries to each of the N annotations. Next, standard cross-entropy (for
the classes) and a linear combination of the L1 and `),Gt=s("a"),tc=n("generalized IoU loss"),oc=n(` (for the
bounding boxes) are used to optimize the parameters of the model.`),za=d(),K=s("p"),nc=n(`DETR can be naturally extended to perform panoptic segmentation (which unifies semantic segmentation and instance
segmentation). `),cn=s("a"),rc=n("DetrForSegmentation"),sc=n(` adds a segmentation mask head on top of
`),ln=s("a"),ac=n("DetrForObjectDetection"),ic=n(`. The mask head can be trained either jointly, or in a two steps process,
where one first trains a `),hn=s("a"),dc=n("DetrForObjectDetection"),cc=n(` model to detect bounding boxes around both
\u201Cthings\u201D (instances) and \u201Cstuff\u201D (background things like trees, roads, sky), then freeze all the weights and train only
the mask head for 25 epochs. Experimentally, these two approaches give similar results. Note that predicting boxes is
required for the training to be possible, since the Hungarian matching is computed using distances between boxes.`),Ca=d(),mn=s("p"),lc=n("Tips:"),Pa=d(),j=s("ul"),ne=s("li"),hc=n("DETR uses so-called "),Or=s("strong"),mc=n("object queries"),pc=n(` to detect objects in an image. The number of queries determines the maximum
number of objects that can be detected in a single image, and is set to 100 by default (see parameter
`),zr=s("code"),fc=n("num_queries"),uc=n(" of "),pn=s("a"),gc=n("DetrConfig"),_c=n(`). Note that it\u2019s good to have some slack (in COCO, the
authors used 100, while the maximum number of objects in a COCO image is ~70).`),bc=d(),Cr=s("li"),vc=n(`The decoder of DETR updates the query embeddings in parallel. This is different from language models like GPT-2,
which use autoregressive decoding instead of parallel. Hence, no causal attention mask is used.`),yc=d(),re=s("li"),Dc=n(`DETR adds position embeddings to the hidden states at each self-attention and cross-attention layer before projecting
to queries and keys. For the position embeddings of the image, one can choose between fixed sinusoidal or learned
absolute position embeddings. By default, the parameter `),Pr=s("code"),wc=n("position_embedding_type"),Tc=n(` of
`),fn=s("a"),xc=n("DetrConfig"),Ec=n(" is set to "),qr=s("code"),$c=n('"sine"'),kc=n("."),Fc=d(),se=s("li"),jc=n(`During training, the authors of DETR did find it helpful to use auxiliary losses in the decoder, especially to help
the model output the correct number of objects of each class. If you set the parameter `),Ir=s("code"),Oc=n("auxiliary_loss"),zc=n(` of
`),un=s("a"),Cc=n("DetrConfig"),Pc=n(" to "),Nr=s("code"),qc=n("True"),Ic=n(`, then prediction feedforward neural networks and Hungarian losses
are added after each decoder layer (with the FFNs sharing parameters).`),Nc=d(),B=s("li"),Ac=n(`If you want to train the model in a distributed environment across multiple nodes, then one should update the
`),Ar=s("em"),Sc=n("num_boxes"),Lc=n(" variable in the "),Sr=s("em"),Rc=n("DetrLoss"),Mc=n(" class of "),Lr=s("em"),Uc=n("modeling_detr.py"),Hc=n(`. When training on multiple nodes, this should be
set to the average number of target boxes across all nodes, as can be seen in the original implementation `),Wt=s("a"),Gc=n("here"),Wc=n("."),Vc=d(),N=s("li"),gn=s("a"),Bc=n("DetrForObjectDetection"),Yc=n(" and "),_n=s("a"),Qc=n("DetrForSegmentation"),Jc=n(` can be initialized with
any convolutional backbone available in the `),Vt=s("a"),Kc=n("timm library"),Xc=n(`.
Initializing with a MobileNet backbone for example can be done by setting the `),Rr=s("code"),Zc=n("backbone"),el=n(` attribute of
`),bn=s("a"),tl=n("DetrConfig"),ol=n(" to "),Mr=s("code"),nl=n('"tf_mobilenetv3_small_075"'),rl=n(`, and then initializing the model with that
config.`),sl=d(),ae=s("li"),al=n(`DETR resizes the input images such that the shortest side is at least a certain amount of pixels while the longest is
at most 1333 pixels. At training time, scale augmentation is used such that the shortest side is randomly set to at
least 480 and at most 800 pixels. At inference time, the shortest side is set to 800. One can use
`),vn=s("a"),il=n("DetrImageProcessor"),dl=n(` to prepare images (and optional annotations in COCO format) for the
model. Due to this resizing, images in a batch can have different sizes. DETR solves this by padding images up to the
largest size in a batch, and by creating a pixel mask that indicates which pixels are real/which are padding.
Alternatively, one can also define a custom `),Ur=s("code"),cl=n("collate_fn"),ll=n(` in order to batch images together, using
`),yn=s("a"),hl=n("pad_and_create_pixel_mask()"),ml=n("."),pl=d(),xe=s("li"),fl=n("The size of the images will determine the amount of memory being used, and will thus determine the "),Hr=s("code"),ul=n("batch_size"),gl=n(`.
It is advised to use a batch size of 2 per GPU. See `),Bt=s("a"),_l=n("this Github thread"),bl=n(" for more info."),qa=d(),Dn=s("p"),vl=n("There are three ways to instantiate a DETR model (depending on what you prefer):"),Ia=d(),wn=s("p"),yl=n("Option 1: Instantiate DETR with pre-trained weights for entire model"),Na=d(),_(Yt.$$.fragment),Aa=d(),Tn=s("p"),Dl=n("Option 2: Instantiate DETR with randomly initialized weights for Transformer, but pre-trained weights for backbone"),Sa=d(),_(Qt.$$.fragment),La=d(),xn=s("p"),wl=n("Option 3: Instantiate DETR with randomly initialized weights for backbone + Transformer"),Ra=d(),_(Jt.$$.fragment),Ma=d(),En=s("p"),Tl=n("As a summary, consider the following table:"),Ua=d(),Ve=s("table"),Gr=s("thead"),ie=s("tr"),Wr=s("th"),xl=n("Task"),El=d(),Vr=s("th"),$l=n("Object detection"),kl=d(),Br=s("th"),Fl=n("Instance segmentation"),jl=d(),Yr=s("th"),Ol=n("Panoptic segmentation"),zl=d(),S=s("tbody"),de=s("tr"),Qr=s("td"),Jr=s("strong"),Cl=n("Description"),Pl=d(),Kr=s("td"),ql=n("Predicting bounding boxes and class labels around objects in an image"),Il=d(),Xr=s("td"),Nl=n("Predicting masks around objects (i.e. instances) in an image"),Al=d(),Zr=s("td"),Sl=n("Predicting masks around both objects (i.e. instances) as well as \u201Cstuff\u201D (i.e. background things like trees and roads) in an image"),Ll=d(),ce=s("tr"),es=s("td"),ts=s("strong"),Rl=n("Model"),Ml=d(),os=s("td"),$n=s("a"),Ul=n("DetrForObjectDetection"),Hl=d(),ns=s("td"),kn=s("a"),Gl=n("DetrForSegmentation"),Wl=d(),rs=s("td"),Fn=s("a"),Vl=n("DetrForSegmentation"),Bl=d(),le=s("tr"),ss=s("td"),as=s("strong"),Yl=n("Example dataset"),Ql=d(),is=s("td"),Jl=n("COCO detection"),Kl=d(),ds=s("td"),Xl=n("COCO detection, COCO panoptic"),Zl=d(),cs=s("td"),eh=n("COCO panoptic"),th=d(),he=s("tr"),Kt=s("td"),ls=s("strong"),oh=n("Format of annotations to provide to"),nh=d(),jn=s("a"),rh=n("DetrImageProcessor"),sh=d(),Ee=s("td"),ah=n("{\u2018image_id\u2019: "),hs=s("code"),ih=n("int"),dh=n(", \u2018annotations\u2019: "),ms=s("code"),ch=n("List[Dict]"),lh=n("} each Dict being a COCO object annotation"),hh=d(),L=s("td"),mh=n("{\u2018image_id\u2019: "),ps=s("code"),ph=n("int"),fh=n(", \u2018annotations\u2019: "),fs=s("code"),uh=n("List[Dict]"),gh=n("}  (in case of COCO detection) or {\u2018file_name\u2019: "),us=s("code"),_h=n("str"),bh=n(", \u2018image_id\u2019: "),gs=s("code"),vh=n("int"),yh=n(", \u2018segments_info\u2019: "),_s=s("code"),Dh=n("List[Dict]"),wh=n("} (in case of COCO panoptic)"),Th=d(),me=s("td"),xh=n("{\u2018file_name\u2019: "),bs=s("code"),Eh=n("str"),$h=n(", \u2018image_id\u2019: "),vs=s("code"),kh=n("int"),Fh=n(", \u2018segments_info\u2019: "),ys=s("code"),jh=n("List[Dict]"),Oh=n("} and masks_path (path to directory containing PNG files of the masks)"),zh=d(),pe=s("tr"),On=s("td"),Ds=s("strong"),Ch=n("Postprocessing"),Ph=n(" (i.e. converting the output of the model to COCO API)"),qh=d(),ws=s("td"),Ts=s("code"),Ih=n("post_process()"),Nh=d(),xs=s("td"),Es=s("code"),Ah=n("post_process_segmentation()"),Sh=d(),Xt=s("td"),$s=s("code"),Lh=n("post_process_segmentation()"),Rh=n(", "),ks=s("code"),Mh=n("post_process_panoptic()"),Uh=d(),fe=s("tr"),Fs=s("td"),js=s("strong"),Hh=n("evaluators"),Gh=d(),Zt=s("td"),Os=s("code"),Wh=n("CocoEvaluator"),Vh=n(" with "),zs=s("code"),Bh=n('iou_types="bbox"'),Yh=d(),$e=s("td"),Cs=s("code"),Qh=n("CocoEvaluator"),Jh=n(" with "),Ps=s("code"),Kh=n('iou_types="bbox"'),Xh=n(" or "),qs=s("code"),Zh=n('"segm"'),em=d(),ue=s("td"),Is=s("code"),tm=n("CocoEvaluator"),om=n(" with "),Ns=s("code"),nm=n('iou_tupes="bbox"'),rm=n(" or "),As=s("code"),sm=n('"segm"'),am=n(", "),Ss=s("code"),im=n("PanopticEvaluator"),Ha=d(),$=s("p"),dm=n(`In short, one should prepare the data either in COCO detection or COCO panoptic format, then use
`),zn=s("a"),cm=n("DetrImageProcessor"),lm=n(" to create "),Ls=s("code"),hm=n("pixel_values"),mm=n(", "),Rs=s("code"),pm=n("pixel_mask"),fm=n(` and optional
`),Ms=s("code"),um=n("labels"),gm=n(`, which can then be used to train (or fine-tune) a model. For evaluation, one should first convert the
outputs of the model using one of the postprocessing methods of `),Cn=s("a"),_m=n("DetrImageProcessor"),bm=n(`. These can
be be provided to either `),Us=s("code"),vm=n("CocoEvaluator"),ym=n(" or "),Hs=s("code"),Dm=n("PanopticEvaluator"),wm=n(`, which allow you to calculate metrics like
mean Average Precision (mAP) and Panoptic Quality (PQ). The latter objects are implemented in the `),eo=s("a"),Tm=n("original repository"),xm=n(". See the "),to=s("a"),Em=n("example notebooks"),$m=n(" for more info regarding evaluation."),Ga=d(),ke=s("h2"),Be=s("a"),Gs=s("span"),_(oo.$$.fragment),km=d(),Ws=s("span"),Fm=n("Resources"),Wa=d(),Pn=s("p"),jm=n("A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with DETR."),Va=d(),_(no.$$.fragment),Ba=d(),qn=s("ul"),ge=s("li"),Om=n("All example notebooks illustrating fine-tuning "),In=s("a"),zm=n("DetrForObjectDetection"),Cm=n(" and "),Nn=s("a"),Pm=n("DetrForSegmentation"),qm=n(" on a custom dataset an be found "),ro=s("a"),Im=n("here"),Nm=n("."),Ya=d(),An=s("p"),Am=n("If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),Qa=d(),Fe=s("h2"),Ye=s("a"),Vs=s("span"),_(so.$$.fragment),Sm=d(),Bs=s("span"),Lm=n("DETR specific outputs"),Ja=d(),je=s("div"),_(ao.$$.fragment),Rm=d(),Ys=s("p"),Mm=n(`Base class for outputs of the DETR encoder-decoder model. This class adds one attribute to Seq2SeqModelOutput,
namely an optional stack of intermediate decoder activations, i.e. the output of each decoder layer, each of them
gone through a layernorm. This is useful when training the model with auxiliary decoding losses.`),Ka=d(),Oe=s("div"),_(io.$$.fragment),Um=d(),co=s("p"),Hm=n("Output type of "),Sn=s("a"),Gm=n("DetrForObjectDetection"),Wm=n("."),Xa=d(),ze=s("div"),_(lo.$$.fragment),Vm=d(),ho=s("p"),Bm=n("Output type of "),Ln=s("a"),Ym=n("DetrForSegmentation"),Qm=n("."),Za=d(),Ce=s("h2"),Qe=s("a"),Qs=s("span"),_(mo.$$.fragment),Jm=d(),Js=s("span"),Km=n("DetrConfig"),ei=d(),Y=s("div"),_(po.$$.fragment),Xm=d(),Pe=s("p"),Zm=n("This is the configuration class to store the configuration of a "),Rn=s("a"),ep=n("DetrModel"),tp=n(`. It is used to instantiate a DETR
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETR
`),fo=s("a"),op=n("facebook/detr-resnet-50"),np=n(" architecture."),rp=d(),qe=s("p"),sp=n("Configuration objects inherit from "),Mn=s("a"),ap=n("PretrainedConfig"),ip=n(` and can be used to control the model outputs. Read the
documentation from `),Un=s("a"),dp=n("PretrainedConfig"),cp=n(" for more information."),lp=d(),_(Je.$$.fragment),ti=d(),Ie=s("h2"),Ke=s("a"),Ks=s("span"),_(uo.$$.fragment),hp=d(),Xs=s("span"),mp=n("DetrImageProcessor"),oi=d(),z=s("div"),_(go.$$.fragment),pp=d(),Zs=s("p"),fp=n("Constructs a Detr image processor."),up=d(),Xe=s("div"),_(_o.$$.fragment),gp=d(),ea=s("p"),_p=n("Preprocess an image or a batch of images so that it can be used by the model."),bp=d(),Ze=s("div"),_(bo.$$.fragment),vp=d(),vo=s("p"),yp=n("Converts the raw output of "),Hn=s("a"),Dp=n("DetrForObjectDetection"),wp=n(` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),Tp=d(),et=s("div"),_(yo.$$.fragment),xp=d(),Do=s("p"),Ep=n("Converts the output of "),Gn=s("a"),$p=n("DetrForSegmentation"),kp=n(" into semantic segmentation maps. Only supports PyTorch."),Fp=d(),tt=s("div"),_(wo.$$.fragment),jp=d(),To=s("p"),Op=n("Converts the output of "),Wn=s("a"),zp=n("DetrForSegmentation"),Cp=n(" into instance segmentation predictions. Only supports PyTorch."),Pp=d(),ot=s("div"),_(xo.$$.fragment),qp=d(),Eo=s("p"),Ip=n("Converts the output of "),Vn=s("a"),Np=n("DetrForSegmentation"),Ap=n(` into image panoptic segmentation predictions. Only supports
PyTorch.`),ni=d(),Ne=s("h2"),nt=s("a"),ta=s("span"),_($o.$$.fragment),Sp=d(),oa=s("span"),Lp=n("DetrFeatureExtractor"),ri=d(),C=s("div"),_(ko.$$.fragment),Rp=d(),rt=s("div"),_(Fo.$$.fragment),Mp=d(),na=s("p"),Up=n("Preprocess an image or a batch of images."),Hp=d(),st=s("div"),_(jo.$$.fragment),Gp=d(),ra=s("p"),Wp=n(`Pads a batch of images with zeros to the size of largest height and width in the batch and returns their
corresponding pixel mask.`),Vp=d(),at=s("div"),_(Oo.$$.fragment),Bp=d(),zo=s("p"),Yp=n("Converts the raw output of "),Bn=s("a"),Qp=n("DetrForObjectDetection"),Jp=n(` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),Kp=d(),it=s("div"),_(Co.$$.fragment),Xp=d(),Po=s("p"),Zp=n("Converts the output of "),Yn=s("a"),ef=n("DetrForSegmentation"),tf=n(" into semantic segmentation maps. Only supports PyTorch."),of=d(),dt=s("div"),_(qo.$$.fragment),nf=d(),Io=s("p"),rf=n("Converts the output of "),Qn=s("a"),sf=n("DetrForSegmentation"),af=n(" into instance segmentation predictions. Only supports PyTorch."),df=d(),ct=s("div"),_(No.$$.fragment),cf=d(),Ao=s("p"),lf=n("Converts the output of "),Jn=s("a"),hf=n("DetrForSegmentation"),mf=n(` into image panoptic segmentation predictions. Only supports
PyTorch.`),si=d(),Ae=s("h2"),lt=s("a"),sa=s("span"),_(So.$$.fragment),pf=d(),aa=s("span"),ff=n("DetrModel"),ai=d(),R=s("div"),_(Lo.$$.fragment),uf=d(),ia=s("p"),gf=n(`The bare DETR Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),_f=d(),Ro=s("p"),bf=n("This model inherits from "),Kn=s("a"),vf=n("PreTrainedModel"),yf=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Df=d(),Mo=s("p"),wf=n("This model is also a PyTorch "),Uo=s("a"),Tf=n("torch.nn.Module"),xf=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Ef=d(),X=s("div"),_(Ho.$$.fragment),$f=d(),Se=s("p"),kf=n("The "),Xn=s("a"),Ff=n("DetrModel"),jf=n(" forward method, overrides the "),da=s("code"),Of=n("__call__"),zf=n(" special method."),Cf=d(),_(ht.$$.fragment),Pf=d(),_(mt.$$.fragment),ii=d(),Le=s("h2"),pt=s("a"),ca=s("span"),_(Go.$$.fragment),qf=d(),la=s("span"),If=n("DetrForObjectDetection"),di=d(),M=s("div"),_(Wo.$$.fragment),Nf=d(),ha=s("p"),Af=n(`DETR Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),Sf=d(),Vo=s("p"),Lf=n("This model inherits from "),Zn=s("a"),Rf=n("PreTrainedModel"),Mf=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Uf=d(),Bo=s("p"),Hf=n("This model is also a PyTorch "),Yo=s("a"),Gf=n("torch.nn.Module"),Wf=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Vf=d(),Z=s("div"),_(Qo.$$.fragment),Bf=d(),Re=s("p"),Yf=n("The "),er=s("a"),Qf=n("DetrForObjectDetection"),Jf=n(" forward method, overrides the "),ma=s("code"),Kf=n("__call__"),Xf=n(" special method."),Zf=d(),_(ft.$$.fragment),eu=d(),_(ut.$$.fragment),ci=d(),Me=s("h2"),gt=s("a"),pa=s("span"),_(Jo.$$.fragment),tu=d(),fa=s("span"),ou=n("DetrForSegmentation"),li=d(),U=s("div"),_(Ko.$$.fragment),nu=d(),ua=s("p"),ru=n(`DETR Model (consisting of a backbone and encoder-decoder Transformer) with a segmentation head on top, for tasks
such as COCO panoptic.`),su=d(),Xo=s("p"),au=n("This model inherits from "),tr=s("a"),iu=n("PreTrainedModel"),du=n(`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),cu=d(),Zo=s("p"),lu=n("This model is also a PyTorch "),en=s("a"),hu=n("torch.nn.Module"),mu=n(` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),pu=d(),ee=s("div"),_(tn.$$.fragment),fu=d(),Ue=s("p"),uu=n("The "),or=s("a"),gu=n("DetrForSegmentation"),_u=n(" forward method, overrides the "),ga=s("code"),bu=n("__call__"),vu=n(" special method."),yu=d(),_(_t.$$.fragment),Du=d(),_(bt.$$.fragment),this.h()},l(o){const h=Jb('[data-svelte="svelte-1phssyn"]',document.head);f=a(h,"META",{name:!0,content:!0}),h.forEach(t),E=c(o),T=a(o,"H1",{class:!0});var on=i(T);u=a(on,"A",{id:!0,class:!0,href:!0});var _a=i(u);x=a(_a,"SPAN",{});var ba=i(x);b(p.$$.fragment,ba),ba.forEach(t),_a.forEach(t),g=c(on),H=a(on,"SPAN",{});var va=i(H);rd=r(va,"DETR"),va.forEach(t),on.forEach(t),wa=c(o),Te=a(o,"H2",{class:!0});var nn=i(Te);He=a(nn,"A",{id:!0,class:!0,href:!0});var ya=i(He);mr=a(ya,"SPAN",{});var Da=i(mr);b(Lt.$$.fragment,Da),Da.forEach(t),ya.forEach(t),sd=c(nn),pr=a(nn,"SPAN",{});var xu=i(pr);ad=r(xu,"Overview"),xu.forEach(t),nn.forEach(t),Ta=c(o),Ge=a(o,"P",{});var mi=i(Ge);id=r(mi,"The DETR model was proposed in "),Rt=a(mi,"A",{href:!0,rel:!0});var Eu=i(Rt);dd=r(Eu,"End-to-End Object Detection with Transformers"),Eu.forEach(t),cd=r(mi,` by
Nicolas Carion, Francisco Massa, Gabriel Synnaeve, Nicolas Usunier, Alexander Kirillov and Sergey Zagoruyko. DETR
consists of a convolutional backbone followed by an encoder-decoder Transformer which can be trained end-to-end for
object detection. It greatly simplifies a lot of the complexity of models like Faster-R-CNN and Mask-R-CNN, which use
things like region proposals, non-maximum suppression procedure and anchor generation. Moreover, DETR can also be
naturally extended to perform panoptic segmentation, by simply adding a mask head on top of the decoder outputs.`),mi.forEach(t),xa=c(o),sn=a(o,"P",{});var $u=i(sn);ld=r($u,"The abstract from the paper is the following:"),$u.forEach(t),Ea=c(o),an=a(o,"P",{});var ku=i(an);fr=a(ku,"EM",{});var Fu=i(fr);hd=r(Fu,`We present a new method that views object detection as a direct set prediction problem. Our approach streamlines the
detection pipeline, effectively removing the need for many hand-designed components like a non-maximum suppression
procedure or anchor generation that explicitly encode our prior knowledge about the task. The main ingredients of the
new framework, called DEtection TRansformer or DETR, are a set-based global loss that forces unique predictions via
bipartite matching, and a transformer encoder-decoder architecture. Given a fixed small set of learned object queries,
DETR reasons about the relations of the objects and the global image context to directly output the final set of
predictions in parallel. The new model is conceptually simple and does not require a specialized library, unlike many
other modern detectors. DETR demonstrates accuracy and run-time performance on par with the well-established and
highly-optimized Faster RCNN baseline on the challenging COCO object detection dataset. Moreover, DETR can be easily
generalized to produce panoptic segmentation in a unified manner. We show that it significantly outperforms competitive
baselines.`),Fu.forEach(t),ku.forEach(t),$a=c(o),_e=a(o,"P",{});var nr=i(_e);md=r(nr,"This model was contributed by "),Mt=a(nr,"A",{href:!0,rel:!0});var ju=i(Mt);pd=r(ju,"nielsr"),ju.forEach(t),fd=r(nr,". The original code can be found "),Ut=a(nr,"A",{href:!0,rel:!0});var Ou=i(Ut);ud=r(Ou,"here"),Ou.forEach(t),gd=r(nr,"."),nr.forEach(t),ka=c(o),We=a(o,"P",{});var pi=i(We);_d=r(pi,"Here\u2019s a TLDR explaining how "),dn=a(pi,"A",{href:!0});var zu=i(dn);bd=r(zu,"DetrForObjectDetection"),zu.forEach(t),vd=r(pi," works:"),pi.forEach(t),Fa=c(o),F=a(o,"P",{});var q=i(F);yd=r(q,`First, an image is sent through a pre-trained convolutional backbone (in the paper, the authors use
ResNet-50/ResNet-101). Let\u2019s assume we also add a batch dimension. This means that the input to the backbone is a
tensor of shape `),ur=a(q,"CODE",{});var Cu=i(ur);Dd=r(Cu,"(batch_size, 3, height, width)"),Cu.forEach(t),wd=r(q,`, assuming the image has 3 color channels (RGB). The CNN backbone
outputs a new lower-resolution feature map, typically of shape `),gr=a(q,"CODE",{});var Pu=i(gr);Td=r(Pu,"(batch_size, 2048, height/32, width/32)"),Pu.forEach(t),xd=r(q,`. This is
then projected to match the hidden dimension of the Transformer of DETR, which is `),_r=a(q,"CODE",{});var qu=i(_r);Ed=r(qu,"256"),qu.forEach(t),$d=r(q,` by default, using a
`),br=a(q,"CODE",{});var Iu=i(br);kd=r(Iu,"nn.Conv2D"),Iu.forEach(t),Fd=r(q," layer. So now, we have a tensor of shape "),vr=a(q,"CODE",{});var Nu=i(vr);jd=r(Nu,"(batch_size, 256, height/32, width/32)."),Nu.forEach(t),Od=r(q,` Next, the
feature map is flattened and transposed to obtain a tensor of shape `),yr=a(q,"CODE",{});var Au=i(yr);zd=r(Au,"(batch_size, seq_len, d_model)"),Au.forEach(t),Cd=r(q,` =
`),Dr=a(q,"CODE",{});var Su=i(Dr);Pd=r(Su,"(batch_size, width/32*height/32, 256)"),Su.forEach(t),qd=r(q,`. So a difference with NLP models is that the sequence length is actually
longer than usual, but with a smaller `),wr=a(q,"CODE",{});var Lu=i(wr);Id=r(Lu,"d_model"),Lu.forEach(t),Nd=r(q," (which in NLP is typically 768 or higher)."),q.forEach(t),ja=c(o),P=a(o,"P",{});var G=i(P);Ad=r(G,"Next, this is sent through the encoder, outputting "),Tr=a(G,"CODE",{});var Ru=i(Tr);Sd=r(Ru,"encoder_hidden_states"),Ru.forEach(t),Ld=r(G,` of the same shape (you can consider
these as image features). Next, so-called `),xr=a(G,"STRONG",{});var Mu=i(xr);Rd=r(Mu,"object queries"),Mu.forEach(t),Md=r(G,` are sent through the decoder. This is a tensor of shape
`),Er=a(G,"CODE",{});var Uu=i(Er);Ud=r(Uu,"(batch_size, num_queries, d_model)"),Uu.forEach(t),Hd=r(G,", with "),$r=a(G,"CODE",{});var Hu=i($r);Gd=r(Hu,"num_queries"),Hu.forEach(t),Wd=r(G,` typically set to 100 and initialized with zeros.
These input embeddings are learnt positional encodings that the authors refer to as object queries, and similarly to
the encoder, they are added to the input of each attention layer. Each object query will look for a particular object
in the image. The decoder updates these embeddings through multiple self-attention and encoder-decoder attention layers
to output `),kr=a(G,"CODE",{});var Gu=i(kr);Vd=r(Gu,"decoder_hidden_states"),Gu.forEach(t),Bd=r(G," of the same shape: "),Fr=a(G,"CODE",{});var Wu=i(Fr);Yd=r(Wu,"(batch_size, num_queries, d_model)"),Wu.forEach(t),Qd=r(G,`. Next, two heads
are added on top for object detection: a linear layer for classifying each object query into one of the objects or \u201Cno
object\u201D, and a MLP to predict bounding boxes for each query.`),G.forEach(t),Oa=c(o),J=a(o,"P",{});var vt=i(J);Jd=r(vt,"The model is trained using a "),jr=a(vt,"STRONG",{});var Vu=i(jr);Kd=r(Vu,"bipartite matching loss"),Vu.forEach(t),Xd=r(vt,`: so what we actually do is compare the predicted classes +
bounding boxes of each of the N = 100 object queries to the ground truth annotations, padded up to the same length N
(so if an image only contains 4 objects, 96 annotations will just have a \u201Cno object\u201D as class and \u201Cno bounding box\u201D as
bounding box). The `),Ht=a(vt,"A",{href:!0,rel:!0});var Bu=i(Ht);Zd=r(Bu,"Hungarian matching algorithm"),Bu.forEach(t),ec=r(vt,` is used to find
an optimal one-to-one mapping of each of the N queries to each of the N annotations. Next, standard cross-entropy (for
the classes) and a linear combination of the L1 and `),Gt=a(vt,"A",{href:!0,rel:!0});var Yu=i(Gt);tc=r(Yu,"generalized IoU loss"),Yu.forEach(t),oc=r(vt,` (for the
bounding boxes) are used to optimize the parameters of the model.`),vt.forEach(t),za=c(o),K=a(o,"P",{});var yt=i(K);nc=r(yt,`DETR can be naturally extended to perform panoptic segmentation (which unifies semantic segmentation and instance
segmentation). `),cn=a(yt,"A",{href:!0});var Qu=i(cn);rc=r(Qu,"DetrForSegmentation"),Qu.forEach(t),sc=r(yt,` adds a segmentation mask head on top of
`),ln=a(yt,"A",{href:!0});var Ju=i(ln);ac=r(Ju,"DetrForObjectDetection"),Ju.forEach(t),ic=r(yt,`. The mask head can be trained either jointly, or in a two steps process,
where one first trains a `),hn=a(yt,"A",{href:!0});var Ku=i(hn);dc=r(Ku,"DetrForObjectDetection"),Ku.forEach(t),cc=r(yt,` model to detect bounding boxes around both
\u201Cthings\u201D (instances) and \u201Cstuff\u201D (background things like trees, roads, sky), then freeze all the weights and train only
the mask head for 25 epochs. Experimentally, these two approaches give similar results. Note that predicting boxes is
required for the training to be possible, since the Hungarian matching is computed using distances between boxes.`),yt.forEach(t),Ca=c(o),mn=a(o,"P",{});var Xu=i(mn);lc=r(Xu,"Tips:"),Xu.forEach(t),Pa=c(o),j=a(o,"UL",{});var A=i(j);ne=a(A,"LI",{});var Dt=i(ne);hc=r(Dt,"DETR uses so-called "),Or=a(Dt,"STRONG",{});var Zu=i(Or);mc=r(Zu,"object queries"),Zu.forEach(t),pc=r(Dt,` to detect objects in an image. The number of queries determines the maximum
number of objects that can be detected in a single image, and is set to 100 by default (see parameter
`),zr=a(Dt,"CODE",{});var eg=i(zr);fc=r(eg,"num_queries"),eg.forEach(t),uc=r(Dt," of "),pn=a(Dt,"A",{href:!0});var tg=i(pn);gc=r(tg,"DetrConfig"),tg.forEach(t),_c=r(Dt,`). Note that it\u2019s good to have some slack (in COCO, the
authors used 100, while the maximum number of objects in a COCO image is ~70).`),Dt.forEach(t),bc=c(A),Cr=a(A,"LI",{});var og=i(Cr);vc=r(og,`The decoder of DETR updates the query embeddings in parallel. This is different from language models like GPT-2,
which use autoregressive decoding instead of parallel. Hence, no causal attention mask is used.`),og.forEach(t),yc=c(A),re=a(A,"LI",{});var wt=i(re);Dc=r(wt,`DETR adds position embeddings to the hidden states at each self-attention and cross-attention layer before projecting
to queries and keys. For the position embeddings of the image, one can choose between fixed sinusoidal or learned
absolute position embeddings. By default, the parameter `),Pr=a(wt,"CODE",{});var ng=i(Pr);wc=r(ng,"position_embedding_type"),ng.forEach(t),Tc=r(wt,` of
`),fn=a(wt,"A",{href:!0});var rg=i(fn);xc=r(rg,"DetrConfig"),rg.forEach(t),Ec=r(wt," is set to "),qr=a(wt,"CODE",{});var sg=i(qr);$c=r(sg,'"sine"'),sg.forEach(t),kc=r(wt,"."),wt.forEach(t),Fc=c(A),se=a(A,"LI",{});var Tt=i(se);jc=r(Tt,`During training, the authors of DETR did find it helpful to use auxiliary losses in the decoder, especially to help
the model output the correct number of objects of each class. If you set the parameter `),Ir=a(Tt,"CODE",{});var ag=i(Ir);Oc=r(ag,"auxiliary_loss"),ag.forEach(t),zc=r(Tt,` of
`),un=a(Tt,"A",{href:!0});var ig=i(un);Cc=r(ig,"DetrConfig"),ig.forEach(t),Pc=r(Tt," to "),Nr=a(Tt,"CODE",{});var dg=i(Nr);qc=r(dg,"True"),dg.forEach(t),Ic=r(Tt,`, then prediction feedforward neural networks and Hungarian losses
are added after each decoder layer (with the FFNs sharing parameters).`),Tt.forEach(t),Nc=c(A),B=a(A,"LI",{});var be=i(B);Ac=r(be,`If you want to train the model in a distributed environment across multiple nodes, then one should update the
`),Ar=a(be,"EM",{});var cg=i(Ar);Sc=r(cg,"num_boxes"),cg.forEach(t),Lc=r(be," variable in the "),Sr=a(be,"EM",{});var lg=i(Sr);Rc=r(lg,"DetrLoss"),lg.forEach(t),Mc=r(be," class of "),Lr=a(be,"EM",{});var hg=i(Lr);Uc=r(hg,"modeling_detr.py"),hg.forEach(t),Hc=r(be,`. When training on multiple nodes, this should be
set to the average number of target boxes across all nodes, as can be seen in the original implementation `),Wt=a(be,"A",{href:!0,rel:!0});var mg=i(Wt);Gc=r(mg,"here"),mg.forEach(t),Wc=r(be,"."),be.forEach(t),Vc=c(A),N=a(A,"LI",{});var Q=i(N);gn=a(Q,"A",{href:!0});var pg=i(gn);Bc=r(pg,"DetrForObjectDetection"),pg.forEach(t),Yc=r(Q," and "),_n=a(Q,"A",{href:!0});var fg=i(_n);Qc=r(fg,"DetrForSegmentation"),fg.forEach(t),Jc=r(Q,` can be initialized with
any convolutional backbone available in the `),Vt=a(Q,"A",{href:!0,rel:!0});var ug=i(Vt);Kc=r(ug,"timm library"),ug.forEach(t),Xc=r(Q,`.
Initializing with a MobileNet backbone for example can be done by setting the `),Rr=a(Q,"CODE",{});var gg=i(Rr);Zc=r(gg,"backbone"),gg.forEach(t),el=r(Q,` attribute of
`),bn=a(Q,"A",{href:!0});var _g=i(bn);tl=r(_g,"DetrConfig"),_g.forEach(t),ol=r(Q," to "),Mr=a(Q,"CODE",{});var bg=i(Mr);nl=r(bg,'"tf_mobilenetv3_small_075"'),bg.forEach(t),rl=r(Q,`, and then initializing the model with that
config.`),Q.forEach(t),sl=c(A),ae=a(A,"LI",{});var xt=i(ae);al=r(xt,`DETR resizes the input images such that the shortest side is at least a certain amount of pixels while the longest is
at most 1333 pixels. At training time, scale augmentation is used such that the shortest side is randomly set to at
least 480 and at most 800 pixels. At inference time, the shortest side is set to 800. One can use
`),vn=a(xt,"A",{href:!0});var vg=i(vn);il=r(vg,"DetrImageProcessor"),vg.forEach(t),dl=r(xt,` to prepare images (and optional annotations in COCO format) for the
model. Due to this resizing, images in a batch can have different sizes. DETR solves this by padding images up to the
largest size in a batch, and by creating a pixel mask that indicates which pixels are real/which are padding.
Alternatively, one can also define a custom `),Ur=a(xt,"CODE",{});var yg=i(Ur);cl=r(yg,"collate_fn"),yg.forEach(t),ll=r(xt,` in order to batch images together, using
`),yn=a(xt,"A",{href:!0});var Dg=i(yn);hl=r(Dg,"pad_and_create_pixel_mask()"),Dg.forEach(t),ml=r(xt,"."),xt.forEach(t),pl=c(A),xe=a(A,"LI",{});var rr=i(xe);fl=r(rr,"The size of the images will determine the amount of memory being used, and will thus determine the "),Hr=a(rr,"CODE",{});var wg=i(Hr);ul=r(wg,"batch_size"),wg.forEach(t),gl=r(rr,`.
It is advised to use a batch size of 2 per GPU. See `),Bt=a(rr,"A",{href:!0,rel:!0});var Tg=i(Bt);_l=r(Tg,"this Github thread"),Tg.forEach(t),bl=r(rr," for more info."),rr.forEach(t),A.forEach(t),qa=c(o),Dn=a(o,"P",{});var xg=i(Dn);vl=r(xg,"There are three ways to instantiate a DETR model (depending on what you prefer):"),xg.forEach(t),Ia=c(o),wn=a(o,"P",{});var Eg=i(wn);yl=r(Eg,"Option 1: Instantiate DETR with pre-trained weights for entire model"),Eg.forEach(t),Na=c(o),b(Yt.$$.fragment,o),Aa=c(o),Tn=a(o,"P",{});var $g=i(Tn);Dl=r($g,"Option 2: Instantiate DETR with randomly initialized weights for Transformer, but pre-trained weights for backbone"),$g.forEach(t),Sa=c(o),b(Qt.$$.fragment,o),La=c(o),xn=a(o,"P",{});var kg=i(xn);wl=r(kg,"Option 3: Instantiate DETR with randomly initialized weights for backbone + Transformer"),kg.forEach(t),Ra=c(o),b(Jt.$$.fragment,o),Ma=c(o),En=a(o,"P",{});var Fg=i(En);Tl=r(Fg,"As a summary, consider the following table:"),Fg.forEach(t),Ua=c(o),Ve=a(o,"TABLE",{});var fi=i(Ve);Gr=a(fi,"THEAD",{});var jg=i(Gr);ie=a(jg,"TR",{});var Et=i(ie);Wr=a(Et,"TH",{});var Og=i(Wr);xl=r(Og,"Task"),Og.forEach(t),El=c(Et),Vr=a(Et,"TH",{});var zg=i(Vr);$l=r(zg,"Object detection"),zg.forEach(t),kl=c(Et),Br=a(Et,"TH",{});var Cg=i(Br);Fl=r(Cg,"Instance segmentation"),Cg.forEach(t),jl=c(Et),Yr=a(Et,"TH",{});var Pg=i(Yr);Ol=r(Pg,"Panoptic segmentation"),Pg.forEach(t),Et.forEach(t),jg.forEach(t),zl=c(fi),S=a(fi,"TBODY",{});var te=i(S);de=a(te,"TR",{});var $t=i(de);Qr=a($t,"TD",{});var qg=i(Qr);Jr=a(qg,"STRONG",{});var Ig=i(Jr);Cl=r(Ig,"Description"),Ig.forEach(t),qg.forEach(t),Pl=c($t),Kr=a($t,"TD",{});var Ng=i(Kr);ql=r(Ng,"Predicting bounding boxes and class labels around objects in an image"),Ng.forEach(t),Il=c($t),Xr=a($t,"TD",{});var Ag=i(Xr);Nl=r(Ag,"Predicting masks around objects (i.e. instances) in an image"),Ag.forEach(t),Al=c($t),Zr=a($t,"TD",{});var Sg=i(Zr);Sl=r(Sg,"Predicting masks around both objects (i.e. instances) as well as \u201Cstuff\u201D (i.e. background things like trees and roads) in an image"),Sg.forEach(t),$t.forEach(t),Ll=c(te),ce=a(te,"TR",{});var kt=i(ce);es=a(kt,"TD",{});var Lg=i(es);ts=a(Lg,"STRONG",{});var Rg=i(ts);Rl=r(Rg,"Model"),Rg.forEach(t),Lg.forEach(t),Ml=c(kt),os=a(kt,"TD",{});var Mg=i(os);$n=a(Mg,"A",{href:!0});var Ug=i($n);Ul=r(Ug,"DetrForObjectDetection"),Ug.forEach(t),Mg.forEach(t),Hl=c(kt),ns=a(kt,"TD",{});var Hg=i(ns);kn=a(Hg,"A",{href:!0});var Gg=i(kn);Gl=r(Gg,"DetrForSegmentation"),Gg.forEach(t),Hg.forEach(t),Wl=c(kt),rs=a(kt,"TD",{});var Wg=i(rs);Fn=a(Wg,"A",{href:!0});var Vg=i(Fn);Vl=r(Vg,"DetrForSegmentation"),Vg.forEach(t),Wg.forEach(t),kt.forEach(t),Bl=c(te),le=a(te,"TR",{});var Ft=i(le);ss=a(Ft,"TD",{});var Bg=i(ss);as=a(Bg,"STRONG",{});var Yg=i(as);Yl=r(Yg,"Example dataset"),Yg.forEach(t),Bg.forEach(t),Ql=c(Ft),is=a(Ft,"TD",{});var Qg=i(is);Jl=r(Qg,"COCO detection"),Qg.forEach(t),Kl=c(Ft),ds=a(Ft,"TD",{});var Jg=i(ds);Xl=r(Jg,"COCO detection, COCO panoptic"),Jg.forEach(t),Zl=c(Ft),cs=a(Ft,"TD",{});var Kg=i(cs);eh=r(Kg,"COCO panoptic"),Kg.forEach(t),Ft.forEach(t),th=c(te),he=a(te,"TR",{});var jt=i(he);Kt=a(jt,"TD",{});var ui=i(Kt);ls=a(ui,"STRONG",{});var Xg=i(ls);oh=r(Xg,"Format of annotations to provide to"),Xg.forEach(t),nh=c(ui),jn=a(ui,"A",{href:!0});var Zg=i(jn);rh=r(Zg,"DetrImageProcessor"),Zg.forEach(t),ui.forEach(t),sh=c(jt),Ee=a(jt,"TD",{});var sr=i(Ee);ah=r(sr,"{\u2018image_id\u2019: "),hs=a(sr,"CODE",{});var e_=i(hs);ih=r(e_,"int"),e_.forEach(t),dh=r(sr,", \u2018annotations\u2019: "),ms=a(sr,"CODE",{});var t_=i(ms);ch=r(t_,"List[Dict]"),t_.forEach(t),lh=r(sr,"} each Dict being a COCO object annotation"),sr.forEach(t),hh=c(jt),L=a(jt,"TD",{});var oe=i(L);mh=r(oe,"{\u2018image_id\u2019: "),ps=a(oe,"CODE",{});var o_=i(ps);ph=r(o_,"int"),o_.forEach(t),fh=r(oe,", \u2018annotations\u2019: "),fs=a(oe,"CODE",{});var n_=i(fs);uh=r(n_,"List[Dict]"),n_.forEach(t),gh=r(oe,"}  (in case of COCO detection) or {\u2018file_name\u2019: "),us=a(oe,"CODE",{});var r_=i(us);_h=r(r_,"str"),r_.forEach(t),bh=r(oe,", \u2018image_id\u2019: "),gs=a(oe,"CODE",{});var s_=i(gs);vh=r(s_,"int"),s_.forEach(t),yh=r(oe,", \u2018segments_info\u2019: "),_s=a(oe,"CODE",{});var a_=i(_s);Dh=r(a_,"List[Dict]"),a_.forEach(t),wh=r(oe,"} (in case of COCO panoptic)"),oe.forEach(t),Th=c(jt),me=a(jt,"TD",{});var Ot=i(me);xh=r(Ot,"{\u2018file_name\u2019: "),bs=a(Ot,"CODE",{});var i_=i(bs);Eh=r(i_,"str"),i_.forEach(t),$h=r(Ot,", \u2018image_id\u2019: "),vs=a(Ot,"CODE",{});var d_=i(vs);kh=r(d_,"int"),d_.forEach(t),Fh=r(Ot,", \u2018segments_info\u2019: "),ys=a(Ot,"CODE",{});var c_=i(ys);jh=r(c_,"List[Dict]"),c_.forEach(t),Oh=r(Ot,"} and masks_path (path to directory containing PNG files of the masks)"),Ot.forEach(t),jt.forEach(t),zh=c(te),pe=a(te,"TR",{});var zt=i(pe);On=a(zt,"TD",{});var wu=i(On);Ds=a(wu,"STRONG",{});var l_=i(Ds);Ch=r(l_,"Postprocessing"),l_.forEach(t),Ph=r(wu," (i.e. converting the output of the model to COCO API)"),wu.forEach(t),qh=c(zt),ws=a(zt,"TD",{});var h_=i(ws);Ts=a(h_,"CODE",{});var m_=i(Ts);Ih=r(m_,"post_process()"),m_.forEach(t),h_.forEach(t),Nh=c(zt),xs=a(zt,"TD",{});var p_=i(xs);Es=a(p_,"CODE",{});var f_=i(Es);Ah=r(f_,"post_process_segmentation()"),f_.forEach(t),p_.forEach(t),Sh=c(zt),Xt=a(zt,"TD",{});var gi=i(Xt);$s=a(gi,"CODE",{});var u_=i($s);Lh=r(u_,"post_process_segmentation()"),u_.forEach(t),Rh=r(gi,", "),ks=a(gi,"CODE",{});var g_=i(ks);Mh=r(g_,"post_process_panoptic()"),g_.forEach(t),gi.forEach(t),zt.forEach(t),Uh=c(te),fe=a(te,"TR",{});var Ct=i(fe);Fs=a(Ct,"TD",{});var __=i(Fs);js=a(__,"STRONG",{});var b_=i(js);Hh=r(b_,"evaluators"),b_.forEach(t),__.forEach(t),Gh=c(Ct),Zt=a(Ct,"TD",{});var _i=i(Zt);Os=a(_i,"CODE",{});var v_=i(Os);Wh=r(v_,"CocoEvaluator"),v_.forEach(t),Vh=r(_i," with "),zs=a(_i,"CODE",{});var y_=i(zs);Bh=r(y_,'iou_types="bbox"'),y_.forEach(t),_i.forEach(t),Yh=c(Ct),$e=a(Ct,"TD",{});var ar=i($e);Cs=a(ar,"CODE",{});var D_=i(Cs);Qh=r(D_,"CocoEvaluator"),D_.forEach(t),Jh=r(ar," with "),Ps=a(ar,"CODE",{});var w_=i(Ps);Kh=r(w_,'iou_types="bbox"'),w_.forEach(t),Xh=r(ar," or "),qs=a(ar,"CODE",{});var T_=i(qs);Zh=r(T_,'"segm"'),T_.forEach(t),ar.forEach(t),em=c(Ct),ue=a(Ct,"TD",{});var Pt=i(ue);Is=a(Pt,"CODE",{});var x_=i(Is);tm=r(x_,"CocoEvaluator"),x_.forEach(t),om=r(Pt," with "),Ns=a(Pt,"CODE",{});var E_=i(Ns);nm=r(E_,'iou_tupes="bbox"'),E_.forEach(t),rm=r(Pt," or "),As=a(Pt,"CODE",{});var $_=i(As);sm=r($_,'"segm"'),$_.forEach(t),am=r(Pt,", "),Ss=a(Pt,"CODE",{});var k_=i(Ss);im=r(k_,"PanopticEvaluator"),k_.forEach(t),Pt.forEach(t),Ct.forEach(t),te.forEach(t),fi.forEach(t),Ha=c(o),$=a(o,"P",{});var O=i($);dm=r(O,`In short, one should prepare the data either in COCO detection or COCO panoptic format, then use
`),zn=a(O,"A",{href:!0});var F_=i(zn);cm=r(F_,"DetrImageProcessor"),F_.forEach(t),lm=r(O," to create "),Ls=a(O,"CODE",{});var j_=i(Ls);hm=r(j_,"pixel_values"),j_.forEach(t),mm=r(O,", "),Rs=a(O,"CODE",{});var O_=i(Rs);pm=r(O_,"pixel_mask"),O_.forEach(t),fm=r(O,` and optional
`),Ms=a(O,"CODE",{});var z_=i(Ms);um=r(z_,"labels"),z_.forEach(t),gm=r(O,`, which can then be used to train (or fine-tune) a model. For evaluation, one should first convert the
outputs of the model using one of the postprocessing methods of `),Cn=a(O,"A",{href:!0});var C_=i(Cn);_m=r(C_,"DetrImageProcessor"),C_.forEach(t),bm=r(O,`. These can
be be provided to either `),Us=a(O,"CODE",{});var P_=i(Us);vm=r(P_,"CocoEvaluator"),P_.forEach(t),ym=r(O," or "),Hs=a(O,"CODE",{});var q_=i(Hs);Dm=r(q_,"PanopticEvaluator"),q_.forEach(t),wm=r(O,`, which allow you to calculate metrics like
mean Average Precision (mAP) and Panoptic Quality (PQ). The latter objects are implemented in the `),eo=a(O,"A",{href:!0,rel:!0});var I_=i(eo);Tm=r(I_,"original repository"),I_.forEach(t),xm=r(O,". See the "),to=a(O,"A",{href:!0,rel:!0});var N_=i(to);Em=r(N_,"example notebooks"),N_.forEach(t),$m=r(O," for more info regarding evaluation."),O.forEach(t),Ga=c(o),ke=a(o,"H2",{class:!0});var bi=i(ke);Be=a(bi,"A",{id:!0,class:!0,href:!0});var A_=i(Be);Gs=a(A_,"SPAN",{});var S_=i(Gs);b(oo.$$.fragment,S_),S_.forEach(t),A_.forEach(t),km=c(bi),Ws=a(bi,"SPAN",{});var L_=i(Ws);Fm=r(L_,"Resources"),L_.forEach(t),bi.forEach(t),Wa=c(o),Pn=a(o,"P",{});var R_=i(Pn);jm=r(R_,"A list of official Hugging Face and community (indicated by \u{1F30E}) resources to help you get started with DETR."),R_.forEach(t),Va=c(o),b(no.$$.fragment,o),Ba=c(o),qn=a(o,"UL",{});var M_=i(qn);ge=a(M_,"LI",{});var qt=i(ge);Om=r(qt,"All example notebooks illustrating fine-tuning "),In=a(qt,"A",{href:!0});var U_=i(In);zm=r(U_,"DetrForObjectDetection"),U_.forEach(t),Cm=r(qt," and "),Nn=a(qt,"A",{href:!0});var H_=i(Nn);Pm=r(H_,"DetrForSegmentation"),H_.forEach(t),qm=r(qt," on a custom dataset an be found "),ro=a(qt,"A",{href:!0,rel:!0});var G_=i(ro);Im=r(G_,"here"),G_.forEach(t),Nm=r(qt,"."),qt.forEach(t),M_.forEach(t),Ya=c(o),An=a(o,"P",{});var W_=i(An);Am=r(W_,"If you\u2019re interested in submitting a resource to be included here, please feel free to open a Pull Request and we\u2019ll review it! The resource should ideally demonstrate something new instead of duplicating an existing resource."),W_.forEach(t),Qa=c(o),Fe=a(o,"H2",{class:!0});var vi=i(Fe);Ye=a(vi,"A",{id:!0,class:!0,href:!0});var V_=i(Ye);Vs=a(V_,"SPAN",{});var B_=i(Vs);b(so.$$.fragment,B_),B_.forEach(t),V_.forEach(t),Sm=c(vi),Bs=a(vi,"SPAN",{});var Y_=i(Bs);Lm=r(Y_,"DETR specific outputs"),Y_.forEach(t),vi.forEach(t),Ja=c(o),je=a(o,"DIV",{class:!0});var yi=i(je);b(ao.$$.fragment,yi),Rm=c(yi),Ys=a(yi,"P",{});var Q_=i(Ys);Mm=r(Q_,`Base class for outputs of the DETR encoder-decoder model. This class adds one attribute to Seq2SeqModelOutput,
namely an optional stack of intermediate decoder activations, i.e. the output of each decoder layer, each of them
gone through a layernorm. This is useful when training the model with auxiliary decoding losses.`),Q_.forEach(t),yi.forEach(t),Ka=c(o),Oe=a(o,"DIV",{class:!0});var Di=i(Oe);b(io.$$.fragment,Di),Um=c(Di),co=a(Di,"P",{});var wi=i(co);Hm=r(wi,"Output type of "),Sn=a(wi,"A",{href:!0});var J_=i(Sn);Gm=r(J_,"DetrForObjectDetection"),J_.forEach(t),Wm=r(wi,"."),wi.forEach(t),Di.forEach(t),Xa=c(o),ze=a(o,"DIV",{class:!0});var Ti=i(ze);b(lo.$$.fragment,Ti),Vm=c(Ti),ho=a(Ti,"P",{});var xi=i(ho);Bm=r(xi,"Output type of "),Ln=a(xi,"A",{href:!0});var K_=i(Ln);Ym=r(K_,"DetrForSegmentation"),K_.forEach(t),Qm=r(xi,"."),xi.forEach(t),Ti.forEach(t),Za=c(o),Ce=a(o,"H2",{class:!0});var Ei=i(Ce);Qe=a(Ei,"A",{id:!0,class:!0,href:!0});var X_=i(Qe);Qs=a(X_,"SPAN",{});var Z_=i(Qs);b(mo.$$.fragment,Z_),Z_.forEach(t),X_.forEach(t),Jm=c(Ei),Js=a(Ei,"SPAN",{});var eb=i(Js);Km=r(eb,"DetrConfig"),eb.forEach(t),Ei.forEach(t),ei=c(o),Y=a(o,"DIV",{class:!0});var It=i(Y);b(po.$$.fragment,It),Xm=c(It),Pe=a(It,"P",{});var ir=i(Pe);Zm=r(ir,"This is the configuration class to store the configuration of a "),Rn=a(ir,"A",{href:!0});var tb=i(Rn);ep=r(tb,"DetrModel"),tb.forEach(t),tp=r(ir,`. It is used to instantiate a DETR
model according to the specified arguments, defining the model architecture. Instantiating a configuration with the
defaults will yield a similar configuration to that of the DETR
`),fo=a(ir,"A",{href:!0,rel:!0});var ob=i(fo);op=r(ob,"facebook/detr-resnet-50"),ob.forEach(t),np=r(ir," architecture."),ir.forEach(t),rp=c(It),qe=a(It,"P",{});var dr=i(qe);sp=r(dr,"Configuration objects inherit from "),Mn=a(dr,"A",{href:!0});var nb=i(Mn);ap=r(nb,"PretrainedConfig"),nb.forEach(t),ip=r(dr,` and can be used to control the model outputs. Read the
documentation from `),Un=a(dr,"A",{href:!0});var rb=i(Un);dp=r(rb,"PretrainedConfig"),rb.forEach(t),cp=r(dr," for more information."),dr.forEach(t),lp=c(It),b(Je.$$.fragment,It),It.forEach(t),ti=c(o),Ie=a(o,"H2",{class:!0});var $i=i(Ie);Ke=a($i,"A",{id:!0,class:!0,href:!0});var sb=i(Ke);Ks=a(sb,"SPAN",{});var ab=i(Ks);b(uo.$$.fragment,ab),ab.forEach(t),sb.forEach(t),hp=c($i),Xs=a($i,"SPAN",{});var ib=i(Xs);mp=r(ib,"DetrImageProcessor"),ib.forEach(t),$i.forEach(t),oi=c(o),z=a(o,"DIV",{class:!0});var W=i(z);b(go.$$.fragment,W),pp=c(W),Zs=a(W,"P",{});var db=i(Zs);fp=r(db,"Constructs a Detr image processor."),db.forEach(t),up=c(W),Xe=a(W,"DIV",{class:!0});var ki=i(Xe);b(_o.$$.fragment,ki),gp=c(ki),ea=a(ki,"P",{});var cb=i(ea);_p=r(cb,"Preprocess an image or a batch of images so that it can be used by the model."),cb.forEach(t),ki.forEach(t),bp=c(W),Ze=a(W,"DIV",{class:!0});var Fi=i(Ze);b(bo.$$.fragment,Fi),vp=c(Fi),vo=a(Fi,"P",{});var ji=i(vo);yp=r(ji,"Converts the raw output of "),Hn=a(ji,"A",{href:!0});var lb=i(Hn);Dp=r(lb,"DetrForObjectDetection"),lb.forEach(t),wp=r(ji,` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),ji.forEach(t),Fi.forEach(t),Tp=c(W),et=a(W,"DIV",{class:!0});var Oi=i(et);b(yo.$$.fragment,Oi),xp=c(Oi),Do=a(Oi,"P",{});var zi=i(Do);Ep=r(zi,"Converts the output of "),Gn=a(zi,"A",{href:!0});var hb=i(Gn);$p=r(hb,"DetrForSegmentation"),hb.forEach(t),kp=r(zi," into semantic segmentation maps. Only supports PyTorch."),zi.forEach(t),Oi.forEach(t),Fp=c(W),tt=a(W,"DIV",{class:!0});var Ci=i(tt);b(wo.$$.fragment,Ci),jp=c(Ci),To=a(Ci,"P",{});var Pi=i(To);Op=r(Pi,"Converts the output of "),Wn=a(Pi,"A",{href:!0});var mb=i(Wn);zp=r(mb,"DetrForSegmentation"),mb.forEach(t),Cp=r(Pi," into instance segmentation predictions. Only supports PyTorch."),Pi.forEach(t),Ci.forEach(t),Pp=c(W),ot=a(W,"DIV",{class:!0});var qi=i(ot);b(xo.$$.fragment,qi),qp=c(qi),Eo=a(qi,"P",{});var Ii=i(Eo);Ip=r(Ii,"Converts the output of "),Vn=a(Ii,"A",{href:!0});var pb=i(Vn);Np=r(pb,"DetrForSegmentation"),pb.forEach(t),Ap=r(Ii,` into image panoptic segmentation predictions. Only supports
PyTorch.`),Ii.forEach(t),qi.forEach(t),W.forEach(t),ni=c(o),Ne=a(o,"H2",{class:!0});var Ni=i(Ne);nt=a(Ni,"A",{id:!0,class:!0,href:!0});var fb=i(nt);ta=a(fb,"SPAN",{});var ub=i(ta);b($o.$$.fragment,ub),ub.forEach(t),fb.forEach(t),Sp=c(Ni),oa=a(Ni,"SPAN",{});var gb=i(oa);Lp=r(gb,"DetrFeatureExtractor"),gb.forEach(t),Ni.forEach(t),ri=c(o),C=a(o,"DIV",{class:!0});var V=i(C);b(ko.$$.fragment,V),Rp=c(V),rt=a(V,"DIV",{class:!0});var Ai=i(rt);b(Fo.$$.fragment,Ai),Mp=c(Ai),na=a(Ai,"P",{});var _b=i(na);Up=r(_b,"Preprocess an image or a batch of images."),_b.forEach(t),Ai.forEach(t),Hp=c(V),st=a(V,"DIV",{class:!0});var Si=i(st);b(jo.$$.fragment,Si),Gp=c(Si),ra=a(Si,"P",{});var bb=i(ra);Wp=r(bb,`Pads a batch of images with zeros to the size of largest height and width in the batch and returns their
corresponding pixel mask.`),bb.forEach(t),Si.forEach(t),Vp=c(V),at=a(V,"DIV",{class:!0});var Li=i(at);b(Oo.$$.fragment,Li),Bp=c(Li),zo=a(Li,"P",{});var Ri=i(zo);Yp=r(Ri,"Converts the raw output of "),Bn=a(Ri,"A",{href:!0});var vb=i(Bn);Qp=r(vb,"DetrForObjectDetection"),vb.forEach(t),Jp=r(Ri,` into final bounding boxes in (top_left_x, top_left_y,
bottom_right_x, bottom_right_y) format. Only supports PyTorch.`),Ri.forEach(t),Li.forEach(t),Kp=c(V),it=a(V,"DIV",{class:!0});var Mi=i(it);b(Co.$$.fragment,Mi),Xp=c(Mi),Po=a(Mi,"P",{});var Ui=i(Po);Zp=r(Ui,"Converts the output of "),Yn=a(Ui,"A",{href:!0});var yb=i(Yn);ef=r(yb,"DetrForSegmentation"),yb.forEach(t),tf=r(Ui," into semantic segmentation maps. Only supports PyTorch."),Ui.forEach(t),Mi.forEach(t),of=c(V),dt=a(V,"DIV",{class:!0});var Hi=i(dt);b(qo.$$.fragment,Hi),nf=c(Hi),Io=a(Hi,"P",{});var Gi=i(Io);rf=r(Gi,"Converts the output of "),Qn=a(Gi,"A",{href:!0});var Db=i(Qn);sf=r(Db,"DetrForSegmentation"),Db.forEach(t),af=r(Gi," into instance segmentation predictions. Only supports PyTorch."),Gi.forEach(t),Hi.forEach(t),df=c(V),ct=a(V,"DIV",{class:!0});var Wi=i(ct);b(No.$$.fragment,Wi),cf=c(Wi),Ao=a(Wi,"P",{});var Vi=i(Ao);lf=r(Vi,"Converts the output of "),Jn=a(Vi,"A",{href:!0});var wb=i(Jn);hf=r(wb,"DetrForSegmentation"),wb.forEach(t),mf=r(Vi,` into image panoptic segmentation predictions. Only supports
PyTorch.`),Vi.forEach(t),Wi.forEach(t),V.forEach(t),si=c(o),Ae=a(o,"H2",{class:!0});var Bi=i(Ae);lt=a(Bi,"A",{id:!0,class:!0,href:!0});var Tb=i(lt);sa=a(Tb,"SPAN",{});var xb=i(sa);b(So.$$.fragment,xb),xb.forEach(t),Tb.forEach(t),pf=c(Bi),aa=a(Bi,"SPAN",{});var Eb=i(aa);ff=r(Eb,"DetrModel"),Eb.forEach(t),Bi.forEach(t),ai=c(o),R=a(o,"DIV",{class:!0});var ve=i(R);b(Lo.$$.fragment,ve),uf=c(ve),ia=a(ve,"P",{});var $b=i(ia);gf=r($b,`The bare DETR Model (consisting of a backbone and encoder-decoder Transformer) outputting raw hidden-states without
any specific head on top.`),$b.forEach(t),_f=c(ve),Ro=a(ve,"P",{});var Yi=i(Ro);bf=r(Yi,"This model inherits from "),Kn=a(Yi,"A",{href:!0});var kb=i(Kn);vf=r(kb,"PreTrainedModel"),kb.forEach(t),yf=r(Yi,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Yi.forEach(t),Df=c(ve),Mo=a(ve,"P",{});var Qi=i(Mo);wf=r(Qi,"This model is also a PyTorch "),Uo=a(Qi,"A",{href:!0,rel:!0});var Fb=i(Uo);Tf=r(Fb,"torch.nn.Module"),Fb.forEach(t),xf=r(Qi,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Qi.forEach(t),Ef=c(ve),X=a(ve,"DIV",{class:!0});var Nt=i(X);b(Ho.$$.fragment,Nt),$f=c(Nt),Se=a(Nt,"P",{});var cr=i(Se);kf=r(cr,"The "),Xn=a(cr,"A",{href:!0});var jb=i(Xn);Ff=r(jb,"DetrModel"),jb.forEach(t),jf=r(cr," forward method, overrides the "),da=a(cr,"CODE",{});var Ob=i(da);Of=r(Ob,"__call__"),Ob.forEach(t),zf=r(cr," special method."),cr.forEach(t),Cf=c(Nt),b(ht.$$.fragment,Nt),Pf=c(Nt),b(mt.$$.fragment,Nt),Nt.forEach(t),ve.forEach(t),ii=c(o),Le=a(o,"H2",{class:!0});var Ji=i(Le);pt=a(Ji,"A",{id:!0,class:!0,href:!0});var zb=i(pt);ca=a(zb,"SPAN",{});var Cb=i(ca);b(Go.$$.fragment,Cb),Cb.forEach(t),zb.forEach(t),qf=c(Ji),la=a(Ji,"SPAN",{});var Pb=i(la);If=r(Pb,"DetrForObjectDetection"),Pb.forEach(t),Ji.forEach(t),di=c(o),M=a(o,"DIV",{class:!0});var ye=i(M);b(Wo.$$.fragment,ye),Nf=c(ye),ha=a(ye,"P",{});var qb=i(ha);Af=r(qb,`DETR Model (consisting of a backbone and encoder-decoder Transformer) with object detection heads on top, for tasks
such as COCO detection.`),qb.forEach(t),Sf=c(ye),Vo=a(ye,"P",{});var Ki=i(Vo);Lf=r(Ki,"This model inherits from "),Zn=a(Ki,"A",{href:!0});var Ib=i(Zn);Rf=r(Ib,"PreTrainedModel"),Ib.forEach(t),Mf=r(Ki,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),Ki.forEach(t),Uf=c(ye),Bo=a(ye,"P",{});var Xi=i(Bo);Hf=r(Xi,"This model is also a PyTorch "),Yo=a(Xi,"A",{href:!0,rel:!0});var Nb=i(Yo);Gf=r(Nb,"torch.nn.Module"),Nb.forEach(t),Wf=r(Xi,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),Xi.forEach(t),Vf=c(ye),Z=a(ye,"DIV",{class:!0});var At=i(Z);b(Qo.$$.fragment,At),Bf=c(At),Re=a(At,"P",{});var lr=i(Re);Yf=r(lr,"The "),er=a(lr,"A",{href:!0});var Ab=i(er);Qf=r(Ab,"DetrForObjectDetection"),Ab.forEach(t),Jf=r(lr," forward method, overrides the "),ma=a(lr,"CODE",{});var Sb=i(ma);Kf=r(Sb,"__call__"),Sb.forEach(t),Xf=r(lr," special method."),lr.forEach(t),Zf=c(At),b(ft.$$.fragment,At),eu=c(At),b(ut.$$.fragment,At),At.forEach(t),ye.forEach(t),ci=c(o),Me=a(o,"H2",{class:!0});var Zi=i(Me);gt=a(Zi,"A",{id:!0,class:!0,href:!0});var Lb=i(gt);pa=a(Lb,"SPAN",{});var Rb=i(pa);b(Jo.$$.fragment,Rb),Rb.forEach(t),Lb.forEach(t),tu=c(Zi),fa=a(Zi,"SPAN",{});var Mb=i(fa);ou=r(Mb,"DetrForSegmentation"),Mb.forEach(t),Zi.forEach(t),li=c(o),U=a(o,"DIV",{class:!0});var De=i(U);b(Ko.$$.fragment,De),nu=c(De),ua=a(De,"P",{});var Ub=i(ua);ru=r(Ub,`DETR Model (consisting of a backbone and encoder-decoder Transformer) with a segmentation head on top, for tasks
such as COCO panoptic.`),Ub.forEach(t),su=c(De),Xo=a(De,"P",{});var ed=i(Xo);au=r(ed,"This model inherits from "),tr=a(ed,"A",{href:!0});var Hb=i(tr);iu=r(Hb,"PreTrainedModel"),Hb.forEach(t),du=r(ed,`. Check the superclass documentation for the generic methods the
library implements for all its model (such as downloading or saving, resizing the input embeddings, pruning heads
etc.)`),ed.forEach(t),cu=c(De),Zo=a(De,"P",{});var td=i(Zo);lu=r(td,"This model is also a PyTorch "),en=a(td,"A",{href:!0,rel:!0});var Gb=i(en);hu=r(Gb,"torch.nn.Module"),Gb.forEach(t),mu=r(td,` subclass.
Use it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage
and behavior.`),td.forEach(t),pu=c(De),ee=a(De,"DIV",{class:!0});var St=i(ee);b(tn.$$.fragment,St),fu=c(St),Ue=a(St,"P",{});var hr=i(Ue);uu=r(hr,"The "),or=a(hr,"A",{href:!0});var Wb=i(or);gu=r(Wb,"DetrForSegmentation"),Wb.forEach(t),_u=r(hr," forward method, overrides the "),ga=a(hr,"CODE",{});var Vb=i(ga);bu=r(Vb,"__call__"),Vb.forEach(t),vu=r(hr," special method."),hr.forEach(t),yu=c(St),b(_t.$$.fragment,St),Du=c(St),b(bt.$$.fragment,St),St.forEach(t),De.forEach(t),this.h()},h(){l(f,"name","hf:doc:metadata"),l(f,"content",JSON.stringify(iv)),l(u,"id","detr"),l(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(u,"href","#detr"),l(T,"class","relative group"),l(He,"id","overview"),l(He,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(He,"href","#overview"),l(Te,"class","relative group"),l(Rt,"href","https://arxiv.org/abs/2005.12872"),l(Rt,"rel","nofollow"),l(Mt,"href","https://huggingface.co/nielsr"),l(Mt,"rel","nofollow"),l(Ut,"href","https://github.com/facebookresearch/detr"),l(Ut,"rel","nofollow"),l(dn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Ht,"href","https://en.wikipedia.org/wiki/Hungarian_algorithm"),l(Ht,"rel","nofollow"),l(Gt,"href","https://giou.stanford.edu/"),l(Gt,"rel","nofollow"),l(cn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(ln,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(hn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(pn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig"),l(fn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig"),l(un,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig"),l(Wt,"href","https://github.com/facebookresearch/detr/blob/a54b77800eb8e64e3ad0d8237789fcbf2f8350c5/models/detr.py#L227-L232"),l(Wt,"rel","nofollow"),l(gn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(_n,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(Vt,"href","https://github.com/rwightman/pytorch-image-models"),l(Vt,"rel","nofollow"),l(bn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrConfig"),l(vn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrImageProcessor"),l(yn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrFeatureExtractor.pad_and_create_pixel_mask"),l(Bt,"href","https://github.com/facebookresearch/detr/issues/150"),l(Bt,"rel","nofollow"),l($n,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(kn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(Fn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(jn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrImageProcessor"),l(zn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrImageProcessor"),l(Cn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrImageProcessor"),l(eo,"href","https://github.com/facebookresearch/detr"),l(eo,"rel","nofollow"),l(to,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/DETR"),l(to,"rel","nofollow"),l(Be,"id","resources"),l(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Be,"href","#resources"),l(ke,"class","relative group"),l(In,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Nn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(ro,"href","https://github.com/NielsRogge/Transformers-Tutorials/tree/master/DETR"),l(ro,"rel","nofollow"),l(Ye,"id","transformers.models.detr.modeling_detr.DetrModelOutput"),l(Ye,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ye,"href","#transformers.models.detr.modeling_detr.DetrModelOutput"),l(Fe,"class","relative group"),l(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Sn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ln,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Qe,"id","transformers.DetrConfig"),l(Qe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Qe,"href","#transformers.DetrConfig"),l(Ce,"class","relative group"),l(Rn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrModel"),l(fo,"href","https://huggingface.co/facebook/detr-resnet-50"),l(fo,"rel","nofollow"),l(Mn,"href","/docs/transformers/v4.26.0/en/main_classes/configuration#transformers.PretrainedConfig"),l(Un,"href","/docs/transformers/v4.26.0/en/main_classes/configuration#transformers.PretrainedConfig"),l(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Ke,"id","transformers.DetrImageProcessor"),l(Ke,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Ke,"href","#transformers.DetrImageProcessor"),l(Ie,"class","relative group"),l(Xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Hn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Gn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Wn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(tt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Vn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(ot,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(nt,"id","transformers.DetrFeatureExtractor"),l(nt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(nt,"href","#transformers.DetrFeatureExtractor"),l(Ne,"class","relative group"),l(rt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(st,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Bn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(at,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Yn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(it,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Qn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(dt,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(Jn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(ct,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(lt,"id","transformers.DetrModel"),l(lt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(lt,"href","#transformers.DetrModel"),l(Ae,"class","relative group"),l(Kn,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel"),l(Uo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Uo,"rel","nofollow"),l(Xn,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrModel"),l(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(pt,"id","transformers.DetrForObjectDetection"),l(pt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(pt,"href","#transformers.DetrForObjectDetection"),l(Le,"class","relative group"),l(Zn,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel"),l(Yo,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(Yo,"rel","nofollow"),l(er,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForObjectDetection"),l(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(gt,"id","transformers.DetrForSegmentation"),l(gt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(gt,"href","#transformers.DetrForSegmentation"),l(Me,"class","relative group"),l(tr,"href","/docs/transformers/v4.26.0/en/main_classes/model#transformers.PreTrainedModel"),l(en,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),l(en,"rel","nofollow"),l(or,"href","/docs/transformers/v4.26.0/en/model_doc/detr#transformers.DetrForSegmentation"),l(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),l(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(o,h){e(document.head,f),m(o,E,h),m(o,T,h),e(T,u),e(u,x),v(p,x,null),e(T,g),e(T,H),e(H,rd),m(o,wa,h),m(o,Te,h),e(Te,He),e(He,mr),v(Lt,mr,null),e(Te,sd),e(Te,pr),e(pr,ad),m(o,Ta,h),m(o,Ge,h),e(Ge,id),e(Ge,Rt),e(Rt,dd),e(Ge,cd),m(o,xa,h),m(o,sn,h),e(sn,ld),m(o,Ea,h),m(o,an,h),e(an,fr),e(fr,hd),m(o,$a,h),m(o,_e,h),e(_e,md),e(_e,Mt),e(Mt,pd),e(_e,fd),e(_e,Ut),e(Ut,ud),e(_e,gd),m(o,ka,h),m(o,We,h),e(We,_d),e(We,dn),e(dn,bd),e(We,vd),m(o,Fa,h),m(o,F,h),e(F,yd),e(F,ur),e(ur,Dd),e(F,wd),e(F,gr),e(gr,Td),e(F,xd),e(F,_r),e(_r,Ed),e(F,$d),e(F,br),e(br,kd),e(F,Fd),e(F,vr),e(vr,jd),e(F,Od),e(F,yr),e(yr,zd),e(F,Cd),e(F,Dr),e(Dr,Pd),e(F,qd),e(F,wr),e(wr,Id),e(F,Nd),m(o,ja,h),m(o,P,h),e(P,Ad),e(P,Tr),e(Tr,Sd),e(P,Ld),e(P,xr),e(xr,Rd),e(P,Md),e(P,Er),e(Er,Ud),e(P,Hd),e(P,$r),e($r,Gd),e(P,Wd),e(P,kr),e(kr,Vd),e(P,Bd),e(P,Fr),e(Fr,Yd),e(P,Qd),m(o,Oa,h),m(o,J,h),e(J,Jd),e(J,jr),e(jr,Kd),e(J,Xd),e(J,Ht),e(Ht,Zd),e(J,ec),e(J,Gt),e(Gt,tc),e(J,oc),m(o,za,h),m(o,K,h),e(K,nc),e(K,cn),e(cn,rc),e(K,sc),e(K,ln),e(ln,ac),e(K,ic),e(K,hn),e(hn,dc),e(K,cc),m(o,Ca,h),m(o,mn,h),e(mn,lc),m(o,Pa,h),m(o,j,h),e(j,ne),e(ne,hc),e(ne,Or),e(Or,mc),e(ne,pc),e(ne,zr),e(zr,fc),e(ne,uc),e(ne,pn),e(pn,gc),e(ne,_c),e(j,bc),e(j,Cr),e(Cr,vc),e(j,yc),e(j,re),e(re,Dc),e(re,Pr),e(Pr,wc),e(re,Tc),e(re,fn),e(fn,xc),e(re,Ec),e(re,qr),e(qr,$c),e(re,kc),e(j,Fc),e(j,se),e(se,jc),e(se,Ir),e(Ir,Oc),e(se,zc),e(se,un),e(un,Cc),e(se,Pc),e(se,Nr),e(Nr,qc),e(se,Ic),e(j,Nc),e(j,B),e(B,Ac),e(B,Ar),e(Ar,Sc),e(B,Lc),e(B,Sr),e(Sr,Rc),e(B,Mc),e(B,Lr),e(Lr,Uc),e(B,Hc),e(B,Wt),e(Wt,Gc),e(B,Wc),e(j,Vc),e(j,N),e(N,gn),e(gn,Bc),e(N,Yc),e(N,_n),e(_n,Qc),e(N,Jc),e(N,Vt),e(Vt,Kc),e(N,Xc),e(N,Rr),e(Rr,Zc),e(N,el),e(N,bn),e(bn,tl),e(N,ol),e(N,Mr),e(Mr,nl),e(N,rl),e(j,sl),e(j,ae),e(ae,al),e(ae,vn),e(vn,il),e(ae,dl),e(ae,Ur),e(Ur,cl),e(ae,ll),e(ae,yn),e(yn,hl),e(ae,ml),e(j,pl),e(j,xe),e(xe,fl),e(xe,Hr),e(Hr,ul),e(xe,gl),e(xe,Bt),e(Bt,_l),e(xe,bl),m(o,qa,h),m(o,Dn,h),e(Dn,vl),m(o,Ia,h),m(o,wn,h),e(wn,yl),m(o,Na,h),v(Yt,o,h),m(o,Aa,h),m(o,Tn,h),e(Tn,Dl),m(o,Sa,h),v(Qt,o,h),m(o,La,h),m(o,xn,h),e(xn,wl),m(o,Ra,h),v(Jt,o,h),m(o,Ma,h),m(o,En,h),e(En,Tl),m(o,Ua,h),m(o,Ve,h),e(Ve,Gr),e(Gr,ie),e(ie,Wr),e(Wr,xl),e(ie,El),e(ie,Vr),e(Vr,$l),e(ie,kl),e(ie,Br),e(Br,Fl),e(ie,jl),e(ie,Yr),e(Yr,Ol),e(Ve,zl),e(Ve,S),e(S,de),e(de,Qr),e(Qr,Jr),e(Jr,Cl),e(de,Pl),e(de,Kr),e(Kr,ql),e(de,Il),e(de,Xr),e(Xr,Nl),e(de,Al),e(de,Zr),e(Zr,Sl),e(S,Ll),e(S,ce),e(ce,es),e(es,ts),e(ts,Rl),e(ce,Ml),e(ce,os),e(os,$n),e($n,Ul),e(ce,Hl),e(ce,ns),e(ns,kn),e(kn,Gl),e(ce,Wl),e(ce,rs),e(rs,Fn),e(Fn,Vl),e(S,Bl),e(S,le),e(le,ss),e(ss,as),e(as,Yl),e(le,Ql),e(le,is),e(is,Jl),e(le,Kl),e(le,ds),e(ds,Xl),e(le,Zl),e(le,cs),e(cs,eh),e(S,th),e(S,he),e(he,Kt),e(Kt,ls),e(ls,oh),e(Kt,nh),e(Kt,jn),e(jn,rh),e(he,sh),e(he,Ee),e(Ee,ah),e(Ee,hs),e(hs,ih),e(Ee,dh),e(Ee,ms),e(ms,ch),e(Ee,lh),e(he,hh),e(he,L),e(L,mh),e(L,ps),e(ps,ph),e(L,fh),e(L,fs),e(fs,uh),e(L,gh),e(L,us),e(us,_h),e(L,bh),e(L,gs),e(gs,vh),e(L,yh),e(L,_s),e(_s,Dh),e(L,wh),e(he,Th),e(he,me),e(me,xh),e(me,bs),e(bs,Eh),e(me,$h),e(me,vs),e(vs,kh),e(me,Fh),e(me,ys),e(ys,jh),e(me,Oh),e(S,zh),e(S,pe),e(pe,On),e(On,Ds),e(Ds,Ch),e(On,Ph),e(pe,qh),e(pe,ws),e(ws,Ts),e(Ts,Ih),e(pe,Nh),e(pe,xs),e(xs,Es),e(Es,Ah),e(pe,Sh),e(pe,Xt),e(Xt,$s),e($s,Lh),e(Xt,Rh),e(Xt,ks),e(ks,Mh),e(S,Uh),e(S,fe),e(fe,Fs),e(Fs,js),e(js,Hh),e(fe,Gh),e(fe,Zt),e(Zt,Os),e(Os,Wh),e(Zt,Vh),e(Zt,zs),e(zs,Bh),e(fe,Yh),e(fe,$e),e($e,Cs),e(Cs,Qh),e($e,Jh),e($e,Ps),e(Ps,Kh),e($e,Xh),e($e,qs),e(qs,Zh),e(fe,em),e(fe,ue),e(ue,Is),e(Is,tm),e(ue,om),e(ue,Ns),e(Ns,nm),e(ue,rm),e(ue,As),e(As,sm),e(ue,am),e(ue,Ss),e(Ss,im),m(o,Ha,h),m(o,$,h),e($,dm),e($,zn),e(zn,cm),e($,lm),e($,Ls),e(Ls,hm),e($,mm),e($,Rs),e(Rs,pm),e($,fm),e($,Ms),e(Ms,um),e($,gm),e($,Cn),e(Cn,_m),e($,bm),e($,Us),e(Us,vm),e($,ym),e($,Hs),e(Hs,Dm),e($,wm),e($,eo),e(eo,Tm),e($,xm),e($,to),e(to,Em),e($,$m),m(o,Ga,h),m(o,ke,h),e(ke,Be),e(Be,Gs),v(oo,Gs,null),e(ke,km),e(ke,Ws),e(Ws,Fm),m(o,Wa,h),m(o,Pn,h),e(Pn,jm),m(o,Va,h),v(no,o,h),m(o,Ba,h),m(o,qn,h),e(qn,ge),e(ge,Om),e(ge,In),e(In,zm),e(ge,Cm),e(ge,Nn),e(Nn,Pm),e(ge,qm),e(ge,ro),e(ro,Im),e(ge,Nm),m(o,Ya,h),m(o,An,h),e(An,Am),m(o,Qa,h),m(o,Fe,h),e(Fe,Ye),e(Ye,Vs),v(so,Vs,null),e(Fe,Sm),e(Fe,Bs),e(Bs,Lm),m(o,Ja,h),m(o,je,h),v(ao,je,null),e(je,Rm),e(je,Ys),e(Ys,Mm),m(o,Ka,h),m(o,Oe,h),v(io,Oe,null),e(Oe,Um),e(Oe,co),e(co,Hm),e(co,Sn),e(Sn,Gm),e(co,Wm),m(o,Xa,h),m(o,ze,h),v(lo,ze,null),e(ze,Vm),e(ze,ho),e(ho,Bm),e(ho,Ln),e(Ln,Ym),e(ho,Qm),m(o,Za,h),m(o,Ce,h),e(Ce,Qe),e(Qe,Qs),v(mo,Qs,null),e(Ce,Jm),e(Ce,Js),e(Js,Km),m(o,ei,h),m(o,Y,h),v(po,Y,null),e(Y,Xm),e(Y,Pe),e(Pe,Zm),e(Pe,Rn),e(Rn,ep),e(Pe,tp),e(Pe,fo),e(fo,op),e(Pe,np),e(Y,rp),e(Y,qe),e(qe,sp),e(qe,Mn),e(Mn,ap),e(qe,ip),e(qe,Un),e(Un,dp),e(qe,cp),e(Y,lp),v(Je,Y,null),m(o,ti,h),m(o,Ie,h),e(Ie,Ke),e(Ke,Ks),v(uo,Ks,null),e(Ie,hp),e(Ie,Xs),e(Xs,mp),m(o,oi,h),m(o,z,h),v(go,z,null),e(z,pp),e(z,Zs),e(Zs,fp),e(z,up),e(z,Xe),v(_o,Xe,null),e(Xe,gp),e(Xe,ea),e(ea,_p),e(z,bp),e(z,Ze),v(bo,Ze,null),e(Ze,vp),e(Ze,vo),e(vo,yp),e(vo,Hn),e(Hn,Dp),e(vo,wp),e(z,Tp),e(z,et),v(yo,et,null),e(et,xp),e(et,Do),e(Do,Ep),e(Do,Gn),e(Gn,$p),e(Do,kp),e(z,Fp),e(z,tt),v(wo,tt,null),e(tt,jp),e(tt,To),e(To,Op),e(To,Wn),e(Wn,zp),e(To,Cp),e(z,Pp),e(z,ot),v(xo,ot,null),e(ot,qp),e(ot,Eo),e(Eo,Ip),e(Eo,Vn),e(Vn,Np),e(Eo,Ap),m(o,ni,h),m(o,Ne,h),e(Ne,nt),e(nt,ta),v($o,ta,null),e(Ne,Sp),e(Ne,oa),e(oa,Lp),m(o,ri,h),m(o,C,h),v(ko,C,null),e(C,Rp),e(C,rt),v(Fo,rt,null),e(rt,Mp),e(rt,na),e(na,Up),e(C,Hp),e(C,st),v(jo,st,null),e(st,Gp),e(st,ra),e(ra,Wp),e(C,Vp),e(C,at),v(Oo,at,null),e(at,Bp),e(at,zo),e(zo,Yp),e(zo,Bn),e(Bn,Qp),e(zo,Jp),e(C,Kp),e(C,it),v(Co,it,null),e(it,Xp),e(it,Po),e(Po,Zp),e(Po,Yn),e(Yn,ef),e(Po,tf),e(C,of),e(C,dt),v(qo,dt,null),e(dt,nf),e(dt,Io),e(Io,rf),e(Io,Qn),e(Qn,sf),e(Io,af),e(C,df),e(C,ct),v(No,ct,null),e(ct,cf),e(ct,Ao),e(Ao,lf),e(Ao,Jn),e(Jn,hf),e(Ao,mf),m(o,si,h),m(o,Ae,h),e(Ae,lt),e(lt,sa),v(So,sa,null),e(Ae,pf),e(Ae,aa),e(aa,ff),m(o,ai,h),m(o,R,h),v(Lo,R,null),e(R,uf),e(R,ia),e(ia,gf),e(R,_f),e(R,Ro),e(Ro,bf),e(Ro,Kn),e(Kn,vf),e(Ro,yf),e(R,Df),e(R,Mo),e(Mo,wf),e(Mo,Uo),e(Uo,Tf),e(Mo,xf),e(R,Ef),e(R,X),v(Ho,X,null),e(X,$f),e(X,Se),e(Se,kf),e(Se,Xn),e(Xn,Ff),e(Se,jf),e(Se,da),e(da,Of),e(Se,zf),e(X,Cf),v(ht,X,null),e(X,Pf),v(mt,X,null),m(o,ii,h),m(o,Le,h),e(Le,pt),e(pt,ca),v(Go,ca,null),e(Le,qf),e(Le,la),e(la,If),m(o,di,h),m(o,M,h),v(Wo,M,null),e(M,Nf),e(M,ha),e(ha,Af),e(M,Sf),e(M,Vo),e(Vo,Lf),e(Vo,Zn),e(Zn,Rf),e(Vo,Mf),e(M,Uf),e(M,Bo),e(Bo,Hf),e(Bo,Yo),e(Yo,Gf),e(Bo,Wf),e(M,Vf),e(M,Z),v(Qo,Z,null),e(Z,Bf),e(Z,Re),e(Re,Yf),e(Re,er),e(er,Qf),e(Re,Jf),e(Re,ma),e(ma,Kf),e(Re,Xf),e(Z,Zf),v(ft,Z,null),e(Z,eu),v(ut,Z,null),m(o,ci,h),m(o,Me,h),e(Me,gt),e(gt,pa),v(Jo,pa,null),e(Me,tu),e(Me,fa),e(fa,ou),m(o,li,h),m(o,U,h),v(Ko,U,null),e(U,nu),e(U,ua),e(ua,ru),e(U,su),e(U,Xo),e(Xo,au),e(Xo,tr),e(tr,iu),e(Xo,du),e(U,cu),e(U,Zo),e(Zo,lu),e(Zo,en),e(en,hu),e(Zo,mu),e(U,pu),e(U,ee),v(tn,ee,null),e(ee,fu),e(ee,Ue),e(Ue,uu),e(Ue,or),e(or,gu),e(Ue,_u),e(Ue,ga),e(ga,bu),e(Ue,vu),e(ee,yu),v(_t,ee,null),e(ee,Du),v(bt,ee,null),hi=!0},p(o,[h]){const on={};h&2&&(on.$$scope={dirty:h,ctx:o}),Je.$set(on);const _a={};h&2&&(_a.$$scope={dirty:h,ctx:o}),ht.$set(_a);const ba={};h&2&&(ba.$$scope={dirty:h,ctx:o}),mt.$set(ba);const va={};h&2&&(va.$$scope={dirty:h,ctx:o}),ft.$set(va);const nn={};h&2&&(nn.$$scope={dirty:h,ctx:o}),ut.$set(nn);const ya={};h&2&&(ya.$$scope={dirty:h,ctx:o}),_t.$set(ya);const Da={};h&2&&(Da.$$scope={dirty:h,ctx:o}),bt.$set(Da)},i(o){hi||(y(p.$$.fragment,o),y(Lt.$$.fragment,o),y(Yt.$$.fragment,o),y(Qt.$$.fragment,o),y(Jt.$$.fragment,o),y(oo.$$.fragment,o),y(no.$$.fragment,o),y(so.$$.fragment,o),y(ao.$$.fragment,o),y(io.$$.fragment,o),y(lo.$$.fragment,o),y(mo.$$.fragment,o),y(po.$$.fragment,o),y(Je.$$.fragment,o),y(uo.$$.fragment,o),y(go.$$.fragment,o),y(_o.$$.fragment,o),y(bo.$$.fragment,o),y(yo.$$.fragment,o),y(wo.$$.fragment,o),y(xo.$$.fragment,o),y($o.$$.fragment,o),y(ko.$$.fragment,o),y(Fo.$$.fragment,o),y(jo.$$.fragment,o),y(Oo.$$.fragment,o),y(Co.$$.fragment,o),y(qo.$$.fragment,o),y(No.$$.fragment,o),y(So.$$.fragment,o),y(Lo.$$.fragment,o),y(Ho.$$.fragment,o),y(ht.$$.fragment,o),y(mt.$$.fragment,o),y(Go.$$.fragment,o),y(Wo.$$.fragment,o),y(Qo.$$.fragment,o),y(ft.$$.fragment,o),y(ut.$$.fragment,o),y(Jo.$$.fragment,o),y(Ko.$$.fragment,o),y(tn.$$.fragment,o),y(_t.$$.fragment,o),y(bt.$$.fragment,o),hi=!0)},o(o){D(p.$$.fragment,o),D(Lt.$$.fragment,o),D(Yt.$$.fragment,o),D(Qt.$$.fragment,o),D(Jt.$$.fragment,o),D(oo.$$.fragment,o),D(no.$$.fragment,o),D(so.$$.fragment,o),D(ao.$$.fragment,o),D(io.$$.fragment,o),D(lo.$$.fragment,o),D(mo.$$.fragment,o),D(po.$$.fragment,o),D(Je.$$.fragment,o),D(uo.$$.fragment,o),D(go.$$.fragment,o),D(_o.$$.fragment,o),D(bo.$$.fragment,o),D(yo.$$.fragment,o),D(wo.$$.fragment,o),D(xo.$$.fragment,o),D($o.$$.fragment,o),D(ko.$$.fragment,o),D(Fo.$$.fragment,o),D(jo.$$.fragment,o),D(Oo.$$.fragment,o),D(Co.$$.fragment,o),D(qo.$$.fragment,o),D(No.$$.fragment,o),D(So.$$.fragment,o),D(Lo.$$.fragment,o),D(Ho.$$.fragment,o),D(ht.$$.fragment,o),D(mt.$$.fragment,o),D(Go.$$.fragment,o),D(Wo.$$.fragment,o),D(Qo.$$.fragment,o),D(ft.$$.fragment,o),D(ut.$$.fragment,o),D(Jo.$$.fragment,o),D(Ko.$$.fragment,o),D(tn.$$.fragment,o),D(_t.$$.fragment,o),D(bt.$$.fragment,o),hi=!1},d(o){t(f),o&&t(E),o&&t(T),w(p),o&&t(wa),o&&t(Te),w(Lt),o&&t(Ta),o&&t(Ge),o&&t(xa),o&&t(sn),o&&t(Ea),o&&t(an),o&&t($a),o&&t(_e),o&&t(ka),o&&t(We),o&&t(Fa),o&&t(F),o&&t(ja),o&&t(P),o&&t(Oa),o&&t(J),o&&t(za),o&&t(K),o&&t(Ca),o&&t(mn),o&&t(Pa),o&&t(j),o&&t(qa),o&&t(Dn),o&&t(Ia),o&&t(wn),o&&t(Na),w(Yt,o),o&&t(Aa),o&&t(Tn),o&&t(Sa),w(Qt,o),o&&t(La),o&&t(xn),o&&t(Ra),w(Jt,o),o&&t(Ma),o&&t(En),o&&t(Ua),o&&t(Ve),o&&t(Ha),o&&t($),o&&t(Ga),o&&t(ke),w(oo),o&&t(Wa),o&&t(Pn),o&&t(Va),w(no,o),o&&t(Ba),o&&t(qn),o&&t(Ya),o&&t(An),o&&t(Qa),o&&t(Fe),w(so),o&&t(Ja),o&&t(je),w(ao),o&&t(Ka),o&&t(Oe),w(io),o&&t(Xa),o&&t(ze),w(lo),o&&t(Za),o&&t(Ce),w(mo),o&&t(ei),o&&t(Y),w(po),w(Je),o&&t(ti),o&&t(Ie),w(uo),o&&t(oi),o&&t(z),w(go),w(_o),w(bo),w(yo),w(wo),w(xo),o&&t(ni),o&&t(Ne),w($o),o&&t(ri),o&&t(C),w(ko),w(Fo),w(jo),w(Oo),w(Co),w(qo),w(No),o&&t(si),o&&t(Ae),w(So),o&&t(ai),o&&t(R),w(Lo),w(Ho),w(ht),w(mt),o&&t(ii),o&&t(Le),w(Go),o&&t(di),o&&t(M),w(Wo),w(Qo),w(ft),w(ut),o&&t(ci),o&&t(Me),w(Jo),o&&t(li),o&&t(U),w(Ko),w(tn),w(_t),w(bt)}}}const iv={local:"detr",sections:[{local:"overview",title:"Overview"},{local:"resources",title:"Resources"},{local:"transformers.models.detr.modeling_detr.DetrModelOutput",title:"DETR specific outputs"},{local:"transformers.DetrConfig",title:"DetrConfig"},{local:"transformers.DetrImageProcessor",title:"DetrImageProcessor"},{local:"transformers.DetrFeatureExtractor",title:"DetrFeatureExtractor"},{local:"transformers.DetrModel",title:"DetrModel"},{local:"transformers.DetrForObjectDetection",title:"DetrForObjectDetection"},{local:"transformers.DetrForSegmentation",title:"DetrForSegmentation"}],title:"DETR"};function dv(I){return Kb(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class gv extends Bb{constructor(f){super();Yb(this,f,dv,av,Qb,{})}}export{gv as default,iv as metadata};
